
* Sam Kortum, Feb. 2010

* Bring in data on market size.

pause on
* Compare France with Denmark and Uruguay
*      
clear

insheet using gdp_capita.csv, names
gen yp86 = yr1986
gen yp92 = yr1992
gen yp93 = yr1993
drop if ccode == ""
replace yp86 = "." if yp86 == ".."
replace yp92 = "." if yp92 == ".."
replace yp93 = "." if yp93 == ".."
destring yp86 yp92 yp93, replace

keep ccode yp86 yp92
sort ccode

save ypercapita, replace


use niels
sort paysnum
* original source for Danish exports: Pedersen's paper, Appendix B, pg. 60
* original source for Danish home sales: Pedersen's thesis, table 6a.
* original source for Uruguayan data: <to complete>

* convert to $ millions
replace dnk93=dnk93/6.4839
save niels1, replace

* French data for 1992
* thousands of French Francs (convert to $millions)
* constructed in ekk\chi0108
use paysf
rename paynum paysnum
rename sun sun92
gen meanfr92 = meanfrf/(1000*5.295) 
gen p95fr92 = p95frf/(1000*5.295) 
gen q3fr92 = q3frf/(1000*5.295) 
gen medfr92 = medfrf/(1000*5.295)
gen q1fr92 = q1frf/(1000*5.295)
gen p5fr92 = p5frf/(1000*5.295)
gen meanpay92 = meanpayf/(1000*5.295)
gen p95pay92 = p95payf/(1000*5.295)
gen q3pay92 = q3payf/(1000*5.295)
gen medpay92 = medpayf/(1000*5.295)
gen q1pay92 = q1payf/(1000*5.295)
gen p5pay92 = p5payf/(1000*5.295)
keep paysnum meanpay92
sort paysnum
merge paysnum using niels1
drop _merge
sort paysnum
save niels1, replace
clear

* French data for 1986
* thousands of French Francs

use paysd
rename paynum paysnum
rename sun sun86

gen p95rat86 = p95ratd 
gen q3rat86 = q3ratd 
gen medrat86 = medratd
gen q1rat86 = q1ratd 

gen meanfr86 = meanfrd/(1000*6.93) 
gen p95fr86 = p95frd/(1000*6.93) 
gen q3fr86 = q3frd/(1000*6.93) 
gen medfr86 = medfrd/(1000*6.93)
gen q1fr86 = q1frd/(1000*6.93)
gen p5fr86 = p5frd/(1000*6.93)
gen meanpay86 = meanpayd/(1000*6.93)
gen p95pay86 = p95payd/(1000*6.93)
gen q3pay86 = q3payd/(1000*6.93)
gen medpay86 = medpayd/(1000*6.93)
gen q1pay86 = q1payd/(1000*6.93)
gen p5pay86 = p5payd/(1000*6.93)
keep paysnum meanpay86 
sort paysnum
merge paysnum using niels1

drop _merge
sort paysnum

* data on absorption in 1992 (see cnty10.do)
merge paysnum using gtrade92
drop _merge
sort paysnum
save niels1, replace
clear


use aerdata
sort paysnum
merge paysnum using niels1
drop _merge
sort paysnum
*  1986 absorption is already in $ millions
rename tabsorp absorp86


/* I commented the drop if dnk93 == . command at the bottom, 
since we may want to keep observations where we have the French-Uruguay match. (Ferdinando) */
* drop if dnk93 == .


/*The file paysf1 is sorted and saved since we need an additional 
merge operation. (Ferdinando)*/
sort paysnum
save paysf1, replace

/* merging the French country code with the concordance file I created (Ferdinando) */
clear
insheet using concordances_uruguay_france.csv
sort paysnum
merge paysnum using paysf1, uniqmaster _merge(_mergeConc)
sort pais
save paysf1, replace

/*preparing Uruguay data for merging*/
use exports_uruguay9.dta, clear
*keeping both 1992 and 1993 since French data is 1992 and Danish is 1993
keep if a_o==1992 | a_o==1993
keep a_o pais mean_sales nomb_pais
rename mean_sales mean_sales_ury
label var mean_sales_ury "uruguay mean sales"

/*The World Bank data reports, for Uruguay:
year							  	1992			1993
 Exports of goods and services (% of GDP)	 	   20 		   19 
 GDP (current US$)				12984659968 	14127630336 
i.e., exports are 2.596*10^9 dollars and 2.68424976  10^9 dollars in 1992 and 
1993.
This is the same order of magnitude of the total sum of exports in the
uruguayan data: a collapse by year reports total_sales = 1.682e+09 and 
1.607e+09 respectively.
Hence we assume the scale is in dollars and divide the 
data by 10^6. */
replace mean_sales = mean_sales/10^6
reshape wide mean_sales, i(pais nomb_pais) j(a_o)


sort pais
merge pais using paysf1, uniqmaster _merge(_mergeUryFr)
sort ccode
merge ccode using ypercapita 

drop if ccode == ""


gen lden93 = ln(dnk93)
gen lfra92 = ln(meanpay92)
gen lfra86 = ln(meanpay86)

gen miss92 = missing(mean_sales_ury1992)
gen miss93 = missing(mean_sales_ury1993)
replace mean_sales_ury1992 = 0 if miss92 == 1
replace mean_sales_ury1993 = 0 if miss93 == 1
gen mean_sales_ury9293 = (mean_sales_ury1992+mean_sales_ury1993)/2
gen luru9293 = ln(mean_sales_ury9293)

gen labs86 = ln(absorp86)
gen labs92 = ln(absorp92)

gen lyp86 = ln(yp86)
gen lyp92 = ln(yp92)

regress lfra86 labs86, robust
regress lfra86 labs86 lyp86, robust

regress lfra92 labs92, robust
regress lfra92 labs92 lyp92, robust

regress lden93 labs92, robust
regress lden93 labs92 lyp92, robust

regress luru9293 labs92, robust
regress luru9293 labs92 lyp92, robust

save data3, replace

gen lxbar = lfra86
gen labs = labs86
gen lyp = lyp86
gen home = 0
replace home = 1 if ccode == "FRA" 
gen dfra86 = 1
gen dfra = 0
gen dden = 0
gen duru = 0
keep lxbar labs lyp home dfra86 dfra dden duru
save d_fra86, replace
clear

use data3
gen lxbar = lfra92
gen labs = labs92
gen lyp = lyp92
gen home = 0
replace home = 1 if ccode == "FRA" 
gen dfra86 = 0
gen dfra = 1
gen dden = 0
gen duru = 0
keep lxbar labs lyp home dfra86 dfra dden duru
save d_fra, replace
clear

use data3
gen lxbar = lden93
gen labs = labs92
gen lyp = lyp92
gen home = 0
replace home = 1 if ccode == "DEN" 
gen dfra86 = 0
gen dfra = 0
gen dden = 1
gen duru = 0
keep lxbar labs lyp home dfra86 dfra dden duru
save d_den, replace
clear

use data3
gen lxbar = luru9293
gen labs = labs92
gen lyp = lyp92
gen home = 0
replace home = 1 if ccode == "URU" 
gen dfra86 = 0
gen dfra = 0
gen dden = 0
gen duru = 1
keep lxbar labs lyp home dfra86 dfra dden duru

append using d_fra
append using d_den
append using d_fra86

regress lxbar labs

regress lxbar home labs lyp

regress lxbar home dfra86 dfra dden duru labs lyp, noconstant

regress lxbar home dfra dden duru labs lyp

test dfra=dden=duru=0

gen labs_fra = dfra*labs
gen labs_den = dden*labs
gen labs_uru = duru*labs

regress lxbar home dfra dden duru labs labs_fra labs_den labs_uru lyp

test dfra=dden=duru=0

regress lxbar home dfra dden duru labs labs_fra labs_den labs_uru lyp

test labs_fra=labs_den=labs_uru=0

regress lxbar home dfra dden duru labs labs_fra labs_den labs_uru lyp

test dfra=dden=duru=labs_fra=labs_den=labs_uru=0
