new;
cls;

@      MOC7TF2R.PRG  @

@  Create moments for Monte Carlo Simulation for EKK revision @

@ Simulate French firms including those not exporting and those not selling in France @
@  save the simulated total exporters by market and total sales by market @
@ Then, pick out exporters that sell in France and calculate and save percentiles @
@ as well as the fraction of firms selling to each string @


@  Based on moc7tf20.prg @


@ Use new data from Francis (8/20/2007) @
@                                           @
@  Compute implications for productivity    @
@   Use new data from Francis               @
@                                           @
@    reparameterize using zeta (imposing rho = -1 and dropping sigma_h @
@                                           @
@    Back out the simgaEn from French entry @
@                                           @
@   Melitz-Chaney case @
@                                                 @ 
@    Account for Exporters being large in France @
@                                                                            @
@ Create set of moments from simulated firms @
@     firms simulated in MOC7FE9.PRG @
@     moments used in GMM estimation test @


@ updated on 8/21/2009 @



OUTPUT FILE = c:\kortum\research\EKK\revision\monte\moc7tf2r.out RESET;


@ PARAMETERS USED TO GENERATE MONTE CARLO DATA @

@  (see, MOC7F1R.PRG) @

@ It is nice to know the parameters we used to simulate the fake data @

nfirm = 230423;   @ number of firms to simulate (match # of French firms including those not sellin in France) @

thetatil = 2.46; 
sigma_a = 1.69; 
sigma_h = .34;
rho_ah =  -0.65; 
lamdatil= .91; 

nsimfirm = nfirm;

@ make sure nsimfirm is divisible by simsize @
simsize = nfirm;    @ number of hypothetical goods (j) per loop @

simlim = nsimfirm/simsize;

ncnty = 113;
ncntyfr = 34;

frvec = zeros(ncnty,1);
frvec[ncntyfr] = 1;

vcnty = seqa(1,1,ncnty);


" ";
" ******************** ";
" Parameters from firm simulation ";
"thetatil = " thetatil;
"sigma_a = " sigma_a;
"sigma_h = " sigma_h;
"rho_ah = " rho_ah;
"lamdatil = " lamdatil;
" ";
" nsimfirm = " nsimfirm;
" simsize = " simsize;
" ";
" ******************** ";


@ Load data on French firms' export destinations (no data on France as a destination) @

@ list of country names @
let cnty = "AFGHAN" "ALBANIA" "ALGERIA" "ANGOLA" "ARGENTIN" "AUSTRALI" "AUSTRIA" "BANGLADE" "BELGIUML"
"BENIN" "BOLIVIA" "BRAZIL" "BULGARIA" "BURKINAF" "BURUNDI" "CAMEROON" "CANADA" "CENAFREP" 
"CHAD" "CHILE" "CHINA" "COLOMBIA" "COSTAR" "COTEDI" "CUBA" "CZECH" "DENMARK" 
"DOMREP" "ECUADOR" "EGYPT" "ELSALV" "ETHIOPIA" "FINLAND" "FRANCE" "GERMANYE" "GERMANYW" 
"GHANA" "GREECE" "GUATEM" "HONDURAS" "HONGKONG" "HUNGARY" "INDIA" "INDONES" "IRAN" "IRAQ" "IRELAND" "ISRAEL" 
"ITALY" "JAMAICA" "JAPAN" "JORDAN" "KENYA" "KOREAS" "KUWAIT" "LIBERIA" "LIBYA" "MADAGASC" "MALAWI" "MALAYSIA" "MALI" "MAURITAN" "MAURITIU" "MEXICO" "MOROCCO" "MOZAMBIQ" "NEPAL" "NETHERL" "NEWZEAL" 
"NICARAG" "NIGER" "NIGERIA" "NORWAY" "OMAN" "PAKISTAN" "PANAMA" "PAPNEWGU" "PARAGUAY" "PERU" 
"PHILIPP" "PORTUGAL" "ROMANIA" "RWANDA" "SAUDI" "SENEGAL" "SIERRAL" "SINGAPO" "SOMALIA" 
"SOUTHAFR" "SPAIN" "SRILANKA" "SUDAN" "SWEDEN" "SWITZER" "SYRIA" "TAIWAN" "TANZANIA" 
"THAILAND" "TOGO" "TRINTOB" "TUNISIA" "TURKEY" "UGANDA" "UK" "US" "URUGUAY" 
"USSR" "VENEZUEL" "VIETNAM" "YUGOSLAV" "ZAIRE" "ZAMBIA" "ZIMBABWE";

@ French data by country (in $ millions) @

load ekkcnty[113,12] = c:\kortum\research\EKK\chi0708\paysd.raw;

xnf = ekkcnty[.,1]; 
sun1 = ekkcnty[.,2];
ventf50 = ekkcnty[.,3];
ventf75 = ekkcnty[.,4];
ventf95 = ekkcnty[.,5];
vfteb50 = ekkcnty[.,6];
vfteb75 = ekkcnty[.,7];
vfteb95 = ekkcnty[.,8];
lam50 = ekkcnty[.,9];
lam75 = ekkcnty[.,10];
lam95 = ekkcnty[.,11];
mventfrn = ekkcnty[.,12];


@ Data on Firms with negative French Sales (in $ millions) @

load ekkneg[113,2] = c:\kortum\research\EKK\chi0708\paysneg.raw;
sunneg = ekkneg[.,1];
xnfneg = ekkneg[.,2];

fnegsun = sunneg./(sunneg+sun1);
fnegxnf = xnfneg./(xnfneg+xnf);


" ";
" country, sunneg, xnfneg, fnegsun, fnegxnf ";
call printfmt((cnty~sunneg~xnfneg~fnegsun~fnegxnf),(0~1~1~1~1));


sun1 = sun1 + sunneg;
xnf = xnf + xnfneg;

meanpay = xnf./sun1;

@ Data on firms exporting to each subset of top 7 most popular destinations @

load ekkseqa[128,2] = c:\kortum\research\EKK\chi0708\seqd.raw;
pay7 = ekkseqa[.,1];
npay7 = ekkseqa[.,2];

@ Simulated Firm dataset, created in MOC7F1R.PRG @

open firmdat = firmdata;   @ sales by country in monte carlo @
open probdat = probdata;  @ probability weight on each monte carlo draw @


@ initialize matrices to store results @

fentry = zeros(ncnty,simlim);
fsales = zeros(ncnty,simlim);

snpay7 = zeros(128,simlim);

fperc50 = zeros(ncnty,simlim);
fperc75 = zeros(ncnty,simlim);
fperc95 = zeros(ncnty,simlim);

ffperc50 = zeros(ncnty,simlim);
ffperc75 = zeros(ncnty,simlim);
ffperc95 = zeros(ncnty,simlim);

lfperc50 = zeros(ncnty,simlim);
lfperc75 = zeros(ncnty,simlim);
lfperc95 = zeros(ncnty,simlim);


@ Loop through, calculating statistics for simsize firms each time @
i = 1;
do while i <= simlim;

   xmat = readr(firmdat,simsize);
   smat = xmat .gt 0;
   pubar = readr(probdat,simsize); 
     
   @  ************************************************* @
   @                                                    @
   @        Calculate statistics on simsize firms        @
   @                                                    @
   @  ************************************************* @   

   
   fentry[.,i] = meanc(pubar.*smat);    @ Number of French firms selling in each country @

   sexpsmat = sumc(delif(smat',frvec));
      
   @ French sales by market, should match data by Law of Large Numbers @
   fsales[.,i] = meanc(pubar.*xmat);    

@ The rest of the statistics condition on both exporting and selling in the French market @

   @ calculate percentiles of exports to each country @
   n = 1;
   do while n<=ncnty;
    if sumc((smat[.,ncntyfr].*smat[.,n])) > 0;
         fmat = xmat[.,n]~pubar;
         fmat = selif(fmat,((smat[.,ncntyfr].*smat[.,n]).>0));
    else;
         fmat = {0 .001};
    endif;
    sfmat = sortc(fmat,1); 
    temp = cumsumc(sfmat[.,2]);
    temp = temp/temp[rows(temp)];
    temp50 = maxc(1|(sumc(temp .< .50)));
    fperc50[n,i] = sfmat[temp50,1];
    temp75 = maxc(1|(sumc(temp .< .75)));
    fperc75[n,i] = sfmat[temp75,1];
    temp95 = maxc(1|(sumc(temp .< .95)));
    fperc95[n,i] = sfmat[temp95,1];
    n = n+1;
   endo;


   @ calculate percentiles of French sales conditional on exporting to each country @
   n = 1;
   do while n<=ncnty;
    if sumc(smat[.,n]) > 0;
         fmat = xmat[.,ncntyfr]~pubar;
         fmat = selif(fmat,((smat[.,ncntyfr].*smat[.,n]).>0));
    else;
         fmat = {0 .001};
    endif;
    sfmat = sortc(fmat,1); 
    temp = cumsumc(sfmat[.,2]);
    temp = temp/temp[rows(temp)];
    temp50 = maxc(1|(sumc(temp .< .50)));
    ffperc50[n,i] = sfmat[temp50,1];
    temp75 = maxc(1|(sumc(temp .< .75)));
    ffperc75[n,i] = sfmat[temp75,1];
    temp95 = maxc(1|(sumc(temp .< .95)));
    ffperc95[n,i] = sfmat[temp95,1];
    n = n+1;
   endo;
 

  @ calculate percentiles of lambdas (equal to zero when firm doesn't export there) @

   lammat = xmat./(xmat[.,ncntyfr]+.001);

   n = 1;
   do while n<=ncnty;
    if sumc(smat[.,n]) > 0;
         lfmat = lammat[.,n]~pubar;
         lfmat = selif(lfmat,((smat[.,ncntyfr].*smat[.,n]).>0));
    else;
         lfmat = {0 .001};
    endif;
    lsfmat = sortc(lfmat,1); 
    temp = cumsumc(lsfmat[.,2]);
    temp = temp/temp[rows(temp)];
    temp50 = maxc(1|(sumc(temp .< .50)));
    lfperc50[n,i] = lsfmat[temp50,1];
    temp75 = maxc(1|(sumc(temp .< .75)));
    lfperc75[n,i] = lsfmat[temp75,1];
    temp95 = maxc(1|(sumc(temp .< .95)));
    lfperc95[n,i] = lsfmat[temp95,1];
    n = n+1;
   endo;


 @ Calculate firms selling to each combination of 7 most popular destinations @
   smatp   = 1000000*smat[.,9] + 100000*smat[.,36] + 10000*smat[.,94] + 1000*smat[.,49]
                     + 100*smat[.,104] + 10*smat[.,68] + 1*smat[.,105];
 
   ii = 1;
   do while ii <=128;
      temp = (smatp .== pay7[ii]).*((smat[.,ncntyfr].*sexpsmat) .> 0);     
      temp = pubar.*temp;
      snpay7[ii,i] = meanc(temp);
      ii = ii + 1;
   endo;
   

   " i = " i;
   i = i + 1;
endo;

closeall;


fsalesa = fsales[ncntyfr,.]';

@ avoid zeros @

fentry = meanc(fentry');   

snpay7 = meanc(snpay7');

fsales = meanc(fsales');

fperc50 = meanc(fperc50');
fperc75 = meanc(fperc75');
fperc95 = meanc(fperc95');

ffperc50 = meanc(ffperc50');
ffperc75 = meanc(ffperc75');
ffperc95 = meanc(ffperc95');

lfperc50 = meanc(lfperc50');
lfperc75 = meanc(lfperc75');
lfperc95 = meanc(lfperc95');

afsales = fsales./fentry;


" ";
" country, Number of French exporters to market,  simulated  ";
call printfmt((cnty~sun1~fentry),(0~1~1));
" ";
" ";
" country, Mean sales in the market,  simulated  ";
call printfmt((cnty~meanpay~afsales),(0~1~1));
" ";
" ";
" country, actual 50th percentile of exports, simulated ";
call printfmt((cnty~vfteb50~fperc50),(0~1~1));
" ";
" country, actual 75th percentile of exports, simulated ";
call printfmt((cnty~vfteb75~fperc75),(0~1~1));
" ";
" country, actual 95th percentile of exports, simulated ";
call printfmt((cnty~vfteb95~fperc95),(0~1~1));
" ";
" country, actual 50th percentile of French sales, simulated ";
call printfmt((cnty~ventf50~ffperc50),(0~1~1));
" ";
" country, actual 75th percentile of French sales, simulated ";
call printfmt((cnty~ventf75~ffperc75),(0~1~1));
" ";
" country, actual 95th percentile of French sales, simulated ";
call printfmt((cnty~ventf95~ffperc95),(0~1~1));
" ";
" country, actual 50th percentile of lambda, simulated ";
call printfmt((cnty~lam50~lfperc50),(0~1~1));
" ";
" country, actual 75th percentile of lambda, simulated ";
call printfmt((cnty~lam75~lfperc75),(0~1~1));
" ";
" country, actual 95th percentile of lambda, simulated ";
call printfmt((cnty~lam95~lfperc95),(0~1~1));
" ";

" ";
" pay7, French firms selling to that set, simulated ";
pay7~npay7~snpay7;
" ";


@ save the moments from the simulated firms, used by gmmtest.prg @

save fentry=fentry;
save fsales=fsales;
save snpay7=snpay7;
save fperc50=fperc50;
save fperc75=fperc75;
save fperc95=fperc95;
save ffperc50=ffperc50;
save ffperc75=ffperc75;
save ffperc95=ffperc95;
save lfperc50=lfperc50;
save lfperc75=lfperc75;
save lfperc95=lfperc95;

