@                        STEM7MC8.PRG                                             @
@                                                                                             @
@                                (Melitz-Chaney version)                     @
@                                                                                              @
@                                                                                             @
@                                                                                             @
@            Create simulation draws for EKK Model                  @
@                                                                                             @
@   Creates a set of lowest cost draws in each destination   @
@                                                                                             @
@                                                                                             @
@   Draw random components of fixed cost & mkt size         @ 
@                                                                                             @
@                                                                                             @
@               updated 8/27/2007                                                @
@                                                                                             @

new;
cls;

OUTPUT FILE = c:\kortum\research\EKK\revision\monte\stem7mc8.out RESET;

ncnty = 113;   @ total number of countries @
ncntyfr = 34;   @ position of France @

simdim = 500000;   @ number of hypothetical goods (j) to simulate costs @


@  *************************************************** @
@                                                                              @
@          Simulation of Source-Specific Costs         @
@                                                                              @
@  *************************************************** @



create vfdat = vfdata with x,1,8;
create arawdat = arawdata with x,ncnty,8; 
create hrawdat = hrawdata with x,ncnty,8; 


j=1;

do while j <= simdim;

   @ *** step 1: calculate cost draws @
   
    @ draw the v's for France @
   
      vf = rndu(1,1);    @ potential French firm @
     
   @ *** step 2: draw shocks to demand and fixed cost  @

   araw = rndn(1,ncnty);
   hraw = rndn(1,ncnty);

    y = writer(vfdat,vf);
   y = writer(arawdat,araw);
   y = writer(hrawdat,hraw);
    
   j = j + 1;
   if (round(j/100) == (j/100));
   " j " j;
   endif;
endo;   


vfdat = close(vfdat);
arawdat = close(arawdat);
hrawdat = close(hrawdat);

end;










