@                                                                    @
@                          BOOTVCOV_25.PRG                               @

@      USE THE SET OF MOMENTS TO:                                     @
@       0-25 25-50, 50-75, 75-100 for each of the 3 sets                       @



@        modified from bootcov3.prg                                   @

@                       (Eliminates bootdatp.prg)        @
@                                                                   @
@         Calculate variance covariance matrix @
@                                                                    @
@                                                                                                    @
@                                                                                                    @                     
@                                                                                                     @
@                             updated 7/24/2009                                         @


NEW;
cls;

OUTPUT FILE = c:\kortum\research\EKK\revision\gmm\bootvcov_25.out RESET;

numitir = 2000;
ncnty = 112;

tprob2 = zeros(ncnty,4);
tprob2[.,1] = .25*ones(ncnty,1);
tprob2[.,2] = .25*ones(ncnty,1);
tprob2[.,3] = .25*ones(ncnty,1);
tprob2[.,4] = .25*ones(ncnty,1);

@  ****  The following is modified @ 

trueprob = tprob2~tprob2~tprob2;
pvecreal1 = vec(trueprob);

tprobvec = trueprob[1,.]';

load ekkseqa[128,2] = c:\kortum\research\EKK\chi1008\seqd.raw;
pay7 = ekkseqa[.,1];
npay7 = ekkseqa[.,2];
pvecreal2 = npay7/sumc(npay7);


@ Now, get the bootstrapped moments @

@ enter Francis 2000 runs @

load ekkcnty[224000,13] = c:\kortum\research\EKK\chi1008\payfin2000p_25.raw;
load ekkseqa[256000,2] = c:\kortum\research\EKK\chi1008\seqfin2000p.raw;


@  ****  The following is modified @ 

payboot = ekkcnty[.,1:12];


seqboot = ekkseqa[.,1];

nummom1 = 4*112 + 4*112 + 4*112;
nummom2 = 128;

nummom = nummom1 + nummom2;

pvecmat1 = zeros(nummom1,numitir);

pvecmat2 = zeros(nummom2,numitir);

itir = 1;
do while itir <= numitir; 
   " itir = " itir;
   startit = 112*(itir-1) + 1;
   endit = 112*itir;
   pmat1 = payboot[startit:endit,.]; 
   pvecmat1[.,itir] = vec(pmat1);

  @ proportions of firms exporting to each subset of top 7 most popular destinations @
 
   startit = 128*(itir-1) + 1;
   endit = 128*itir;
   pmat2 = seqboot[startit:endit,.]; 
   pvecmat2[.,itir] = pmat2;
 
   itir = itir + 1;
endo;


@ for bootstrapped variance, subtract out what you get from the data itself @

dpvecmat1 = pvecmat1 - pvecreal1;

vcmat1 = dpvecmat1*dpvecmat1';
vcmat1 = vcmat1/numitir;

dpvecmat2 = pvecmat2 - pvecreal2;

vcmat2 = dpvecmat2*dpvecmat2';
vcmat2 = vcmat2/numitir;


vcmat = zeros(nummom,nummom);
vcmat[1:nummom1,1:nummom1] = vcmat1;
vcmat[(nummom1+1):nummom,(nummom1+1):nummom] = vcmat2;

save vcmat = vcmat;

@  *** double check by comparing to binomial variance **** @

@ French data by country (in $ millions) @

load ekkcnty[113,12] = c:\kortum\research\EKK\chi0708\paysd.raw;

xnf = ekkcnty[.,1]; 
sun1 = ekkcnty[.,2];

ncntyfr = 34;   @ position of France @
frvec = zeros(113,1);
frvec[ncntyfr] = 1;

sun112 = delif(sun1,frvec);

vcmat13 = vcmat[1:1344,1:1344];


cnty = 1;
do while cnty <= 112;
   vec13i = seqa(cnty,112,12);
   cmat13 = vcmat13[vec13i,vec13i];
   truesvar = tprobvec.*(1-tprobvec)/sun112[cnty];
   " ";
   " cnty " cnty;
   " diag(cmat13)~truesvar ";
   (diag(cmat13)~truesvar);
    cnty = cnty+1;
endo;  

@ now check for strings of 7 @

truesvar = pvecreal2.*(1-pvecreal2)/sumc(npay7);
" ";
" need to magnify them to see they're not zero ";
" 1000*diag(vcmat2)~1000*truesvar ";
((1000*diag(vcmat2))~(1000*truesvar));


@ eigenvalues come out in increasing order @

{va,ve} = eighv(vcmat);

vapos = (va .> .00000000001);

myrank = rank(vcmat);

" ";
" check that the following are equal ";
" sumc(vapos) " sumc(vapos);
" rank(vcmat) " myrank;

firstpos = nummom-myrank+1;
allposeig = va[firstpos:nummom];

iva = zeros(nummom,1);

iva[firstpos:nummom] = 1/allposeig; 

iva = diagrv(eye(nummom),iva);

ivcmat25 = ve*iva*ve';

save ivcmat25 = ivcmat25;



