@                                                                    @
@                          GMMSAVC3.PRG                               @


@  Estimation program with a reduced set of moments  @
@   modified from GMMSAVC1.PRG                       @


@     GOT RID of ALL the CHI-SQUARE WEIGHTS						     @

@      Change the weighting on the first stage using inverse variance-covariance matrix @

@      Only consider exporting firms                                   @

@   inverse of first stage variance covariance matrix used as weights  @

@   use variance covariance matrix from Francis' bootstraps as weights @

@  Don't Transform the Parameters                                    @


@  Calibrate aggregates, including # and exports of firms with negative French sales @

@                                                                   @
@           Use the latest data from Francis                        @
@                                                                   @
@    Drop 95th percentile of export intensity moments              @
@           Fixed-Effects Approach                                 @
@                         					    @
@                                                                   @
@         Weight Moments by inverse of their variance               @
@                                                                    @
@                 GMM estimation using real momentws                 @
@                                                                       @
@                         Melitz-Chaney version                                      @
@                                                                                    @
@                                                                                    @                     
@                                                                                    @
@                             updated 7/20/2009                                      @


NEW;
cls;

OUTPUT FILE = c:\kortum\research\EKK\revision\gmm\gmmsavc3.out RESET;

@    load inverse first-stage bootstrapped variance covariance matrix @

load ivcmat3=ivcmat3;

@ ********************************************* @
@                                                                      @  
 @                Set the size of the simulation       @
@                  <= size of stem cell bank            @
@                                                                       @
@ ********************************************* @

@ make sure simlim*simsize <= simdim from stemcell program @

simlim = 100;   @ number of times to loop through @
simsize = 5000;    @ number of hypothetical goods (j) per loop @


@ Initialize parameters @
@  The model has 5 parameters @


thetatil = 3;                                     @ theta/(sigma-1) @
sigma_a = 2;                         @ std. dev. of log alpha (random size of a good) @
sigma_h = .5;                         @ std. dev. of log eta (entry shock, alpha/epsilon) @
rho_ah = 0;                                 @ correlation between log alpha and log eta @
lamdatil= .1;                      @ shape of the nu function @


thetatil = 2; 
sigma_a = 1; 
sigma_h = .1; 
rho_ah = 0; 
lamdatil= 1; 


@ Estimates from first stage (gmmsav1.out saved as gmmsav1_newboot1.prg) @
thetatil = 2.463; 
sigma_a = 1.688; 
sigma_h = 0.3397; 
rho_ah = -0.6477; 
lamdatil = 0.9086; 


parvec0 = thetatil|sigma_a|sigma_h|rho_ah|lamdatil;


@ location of the parameters we want to estimate @
locest = {1,2,3,4,5};

" ";
" ******************** ";
" INITIAL VALUES ";
"thetatil = " thetatil;
"sigma_a = " sigma_a;
"sigma_h = " sigma_h;
"rho_ah = " rho_ah;
"lamdatil = " lamdatil;
" ";
"simlim = " simlim;
"simsize = " simsize;
" ";
" locest = " locest';
" ******************** ";



@ percentage perturbation to parameters to form simplex @
addpar = 1*ones(rows(locest),1);

tparvec = parvec0;
parvec = parvec0;


proc trans(parvec);
  thetatil = parvec[1];
  sigma_a = parvec[2];
  sigma_h = parvec[3];
  rho_ah = parvec[4];
  lamdatil = parvec[5];                      
       
  tparvec[1] = thetatil;
  tparvec[2] = sigma_a;
  tparvec[3] = sigma_h;
  tparvec[4] = rho_ah;
  tparvec[5] = lamdatil;

  retp(tparvec);
endp;

proc untrans(tparvec);
   parvec[1] = tparvec[1];
   parvec[2] = tparvec[2];
   parvec[3] = tparvec[3];
   parvec[4] = tparvec[4];
   parvec[5] = tparvec[5];

  thetatil = parvec[1];
  sigma_a = parvec[2];
  sigma_h = parvec[3];
  rho_ah = parvec[4];
  lamdatil = parvec[5];                      
                
  retp(parvec);
endp;   

tparvec = trans(parvec0);

tpar0 = tparvec[locest];

@ initialize components of the objective function @
myfit = 0;

vmyfit = zeros(10,1);

@ evaluate percentiles of sales distribution @
vpercent = {.01,.05,.1,.25,.5,.75,.9,.95,.99};

@ ************** @
@                      @
@  Get the data @
@                       @
@  *************  @

ncnty = 113;
ncntyfr = 34;   @ position of France @

vcnty = seqa(1,1,ncnty);

frvec = zeros(ncnty,1);
frvec[ncntyfr] = 1;


format /rd 16,4;

@ list of country names @
let cnty = "AFGHAN" "ALBANIA" "ALGERIA" "ANGOLA" "ARGENTIN" "AUSTRALI" "AUSTRIA" "BANGLADE" "BELGIUML"
"BENIN" "BOLIVIA" "BRAZIL" "BULGARIA" "BURKINAF" "BURUNDI" "CAMEROON" "CANADA" "CENAFREP" 
"CHAD" "CHILE" "CHINA" "COLOMBIA" "COSTAR" "COTEDI" "CUBA" "CZECH" "DENMARK" 
"DOMREP" "ECUADOR" "EGYPT" "ELSALV" "ETHIOPIA" "FINLAND" "FRANCE" "GERMANYE" "GERMANYW" 
"GHANA" "GREECE" "GUATEM" "HONDURAS" "HONGKONG" "HUNGARY" "INDIA" "INDONES" "IRAN" "IRAQ" "IRELAND" "ISRAEL" 
"ITALY" "JAMAICA" "JAPAN" "JORDAN" "KENYA" "KOREAS" "KUWAIT" "LIBERIA" "LIBYA" "MADAGASC" "MALAWI" 
"MALAYSIA" "MALI" "MAURITAN" "MAURITIU" "MEXICO" "MOROCCO" "MOZAMBIQ" "NEPAL" "NETHERL" "NEWZEAL" 
"NICARAG" "NIGER" "NIGERIA" "NORWAY" "OMAN" "PAKISTAN" "PANAMA" "PAPNEWGU" "PARAGUAY" "PERU" 
"PHILIPP" "PORTUGAL" "ROMANIA" "RWANDA" "SAUDI" "SENEGAL" "SIERRAL" "SINGAPO" "SOMALIA" 
"SOUTHAFR" "SPAIN" "SRILANKA" "SUDAN" "SWEDEN" "SWITZER" "SYRIA" "TAIWAN" "TANZANIA" 
"THAILAND" "TOGO" "TRINTOB" "TUNISIA" "TURKEY" "UGANDA" "UK" "US" "URUGUAY" 
"USSR" "VENEZUEL" "VIETNAM" "YUGOSLAV" "ZAIRE" "ZAMBIA" "ZIMBABWE";


@ French data by country (in $ millions) @

load ekkcnty[113,12] = c:\kortum\research\EKK\chi0708\paysd.raw;

xnf = ekkcnty[.,1]; 
sun1 = ekkcnty[.,2];
ventf50 = ekkcnty[.,3];
ventf75 = ekkcnty[.,4];
ventf95 = ekkcnty[.,5];
vfteb50 = ekkcnty[.,6];
vfteb75 = ekkcnty[.,7];
vfteb95 = ekkcnty[.,8];
lam50 = ekkcnty[.,9];
lam75 = ekkcnty[.,10];
lam95 = ekkcnty[.,11];
mventfrn = ekkcnty[.,12];


@ Data on Firms with negative French Sales (in $ millions) @

load ekkneg[113,2] = c:\kortum\research\EKK\chi0708\paysneg.raw;
sunneg = ekkneg[.,1];
xnfneg = ekkneg[.,2];

fnegsun = sunneg./(sunneg+sun1);
fnegxnf = xnfneg./(xnfneg+xnf);

" sumc(xnfneg) ";
sumc(xnfneg);
" sumc(xnf) ";
sumc(xnf);
" sumc(xnf) - xnf[ncntyfr] ";
(sumc(xnf) - xnf[ncntyfr]);



" ";
" country, sunneg, xnfneg, fnegsun, fnegxnf ";
call printfmt((cnty~sunneg~xnfneg~fnegsun~fnegxnf),(0~1~1~1~1));

oldsun = sun1;

sun1 = sun1 + sunneg;
xnf = xnf + xnfneg;


xbarnf = xnf./sun1;


@ Data on firms exporting to each subset of top 7 most popular destinations @

load ekkseqa[128,2] = c:\kortum\research\EKK\chi0708\seqd.raw;
pay7 = ekkseqa[.,1];
npay7 = ekkseqa[.,2];


mfreq=zeros(ncnty,3);
fmfreq=zeros(ncnty,3);
lmfreq=zeros(ncnty,3);

trueprob = zeros(ncnty,4);
trueprob[.,1] = .5*ones(ncnty,1);
trueprob[.,2] = .25*ones(ncnty,1);
trueprob[.,3] = .2*ones(ncnty,1);
trueprob[.,4] = .05*ones(ncnty,1);

tprob2 = zeros(ncnty,3);
tprob2[.,1] = .5*ones(ncnty,1);
tprob2[.,2] = .25*ones(ncnty,1);
tprob2[.,3] = .25*ones(ncnty,1);

 
proc(5) = firmsim;
   local sigmaen,ithetat,bigpow,z1,letavec,etavec, 
   i,gamparm,itdim,ptilmat,ptil0,xneta,etapow,const1,limgam,
   cgam,guts1,ptil1,ptilnew,ptil,biggam,ptilmel,psmatp,
   utildat,vfdat,arawdat,hrawdat,arawdatw,hrawdatw,fsalesb,esalesb,fentry,
   expbmore,pass25,pass50,pass75,pass95,fpass50,fpass75,fpass95,n,utilde,
   vf,araw,hraw,leta,lalpha,lubarm,lubar,arawi,araww,hrawi,hraww,
   ubar,uf,luf,pubar,hurdle1,hurdle2,smat,smatp,ii,z1t,sale7f,msale7f,sale7fii,
   lxmat,xmat,smat2,xmat2,sexpsmat,ebmore,mfsalesb,
   mesalesb,fmat,sfmat,afsalesb,aesalesb,temp,snpay7,fsales,afsales,temploc,
   mfsalesn,sentsmat,ekmore,mfsalesk,fsalesn,afsalesn,fsalesk,afsalesk,expkmore,fpercti,
   lapass50,lapass75,lapass95,lammat,etmat,et,
   lamstar,okappa1,kappa1,kappa2,biglam,urel,nu,lubarx;


@ ******************************** @
@                                                  @
@   Stage 2 of simulation:            @
@  Calculate price level function @
@                                                  @
@  *******************************  @

ithetat = 1/thetatil;
gamparm = 1-ithetat;

lamstar = lamdatil/(thetatil+lamdatil-1);

okappa1 = exp((sigma_a^2 + sigma_h^2*(thetatil-1)^2+2*rho_ah*sigma_a*sigma_h*(thetatil-1))/2);

kappa2 = exp((sigma_h*thetatil)^2/2);

kappa1 = okappa1*(lamstar/gamparm);

sigmaen = (kappa2/kappa1)*xbarnf;  @ sigma times country specific fixed cost @

biglam = (xnf./kappa1)./sigmaen;


@ ******************************** @
@                                                  @
@   Stage 3 of simulation:            @
@  Calculate firm-level behavior  @
@                                                  @
@  *******************************  @


 @ simulation draws from STEMMC2.PRG @

     open vfdat = vfdata; 
     open arawdat = arawdata;
     open hrawdat = hrawdata;

@ Loop through reading simsize draws each time, from stemcell @

@ initialize matrices to store results @
fentry = zeros(ncnty,simlim);

etmat = fentry;

pass25 = zeros(ncnty,simlim);
pass50 = zeros(ncnty,simlim);
pass75 = zeros(ncnty,simlim);
pass95 = zeros(ncnty,simlim);
fpass50 = zeros(ncnty,simlim);
fpass75 = zeros(ncnty,simlim);
fpass95 = zeros(ncnty,simlim);
snpay7 = zeros(128,simlim);
lapass50 = zeros(ncnty,simlim);
lapass75 = zeros(ncnty,simlim);
lapass95 = zeros(ncnty,simlim);


i = 1;
do while i <= simlim;

     vf = readr(vfdat,simsize);
    araw = readr(arawdat,simsize);
    hraw = readr(hrawdat,simsize);
    
@  ***************************************** @
@                                                                 @
@  Step a: mkt size and fixed cost shocks @
@                                                                  @
@  ****************************************** @

   leta = sigma_h*hraw;
   lalpha = sigma_a*sqrt((1-rho_ah^2))*araw + sigma_a*rho_ah*hraw;

   clear araw, hraw;


@  ********************************************* @
@                                                                      @
@  Steps b and c: calculate ubar's and uf's     @
@                                                                       @
@  ********************************************* @   
    
     et = exp(thetatil*leta);

     lubarm = thetatil*leta + ln(biglam');

     @ hurdle for exporting and selling in France @
     lubarx = maxc(delif(lubarm',frvec));
     lubar = minc((lubarx~lubarm[.,ncntyfr])');

     ubar=exp(lubar);

     uf = vf.*ubar;

     pubar = ubar;

@  ************************************************* @
@                                                                            @
@  Steps d and e: French firm entry and sales     @
@                                                                            @
@  ************************************************* @   

    luf = ln(uf);

    hurdle1 = (lubarm .>= luf);     @ the entry hurdles @

   smat = hurdle1;  @ entry vector,  need to pass hurdles @

   uf = exp(luf);
  
   urel = exp(luf - lubarm);
   nu = 1-urel^(lamdatil/thetatil);
   nu = smat.*nu + (1-smat);

   lxmat = ln(nu) + lalpha + ithetat*ln(biglam') + ln(sigmaen') - ithetat*luf; 

   xmat = smat.*exp(lxmat);

clear lxmat;




@  ************************************************* @
@                                                                            @
@             Calculate some statistics                      @
@                                                                            @
@  ************************************************* @   



   @  ************************************************* @
   @                                                    @
   @        Calculate statistics on simsize firms        @
   @                                                    @
   @  ************************************************* @   

   @ Correct for over sampling of high cost firms @
    smat2 = pubar.*smat;


fentry[.,i] = meanc(smat2);    @ Number of French firms selling in each country @

temp = delif(smat',frvec);
sexpsmat = sumc(temp);

@ calculate firms passing country specific export percentiles @


temp = pubar.*(xmat .> vfteb50');  
pass50[.,i] = meanc(temp);
temp = pubar.*(xmat .> vfteb75');  
pass75[.,i] = meanc(temp); 
temp = pubar.*(xmat .> vfteb95');  
pass95[.,i] = meanc(temp);  


@ calculate exporters to particular markets passing French sales percentiles @

temp = pubar.*(smat.*xmat[.,ncntyfr] .> ventf50');  
fpass50[.,i] = meanc(temp);  
temp = pubar.*(smat.*xmat[.,ncntyfr] .> ventf75');  
fpass75[.,i] = meanc(temp);  
temp = pubar.*(smat.*xmat[.,ncntyfr] .> ventf95');  
fpass95[.,i] = meanc(temp);    

@ calculate lambdas (equal to zero when firm doesn't export there) @

lammat = xmat./xmat[.,ncntyfr];

@ calculate firms whose lambda passes country specific percentile @


temp = pubar.*(lammat .> lam50');  
lapass50[.,i] = meanc(temp);  
temp = pubar.*(lammat .> lam75');  
lapass75[.,i] = meanc(temp);  
temp = pubar.*(lammat .> lam95');  
lapass95[.,i] = meanc(temp);  


@ Calculate firms selling to each combination of 7 most popular destinations @
@ Belgium(9), Germany(36), Swizerland(94), Italy(49), UK(104), Netherlands(68), USA(105) and exporters to none of these @

smatp   = 1000000*smat[.,9] + 100000*smat[.,36] + 10000*smat[.,94] + 1000*smat[.,49]
                     + 100*smat[.,104] + 10*smat[.,68] + 1*smat[.,105];   

ii = 1;
do while ii <=128;
  temp = (smatp .== pay7[ii]).*(sexpsmat .> 0);     
  temp = pubar.*temp;
  snpay7[ii,i] = meanc(temp);
  ii = ii + 1;
endo;


i = i+1;
 
endo;

      vfdat = close(vfdat); 
     arawdat = close(arawdat); 
     hrawdat = close(hrawdat); 

@ average the results @


fentry = meanc(fentry')+.0001;    @ avoid zeros @
pass50 = meanc(pass50')+.000001;
pass75 = meanc(pass75')+.000001;
pass95 = meanc(pass95')+.000001;
fpass50 = meanc(fpass50')+.000001;
fpass75 = meanc(fpass75')+.000001;
fpass95 = meanc(fpass95')+.000001;

lapass50 = meanc(lapass50')+.000001;
lapass75 = meanc(lapass75')+.000001;
lapass95 = meanc(lapass95')+.000001;

snpay7 = meanc(snpay7')+.000001;


@ number in mutually exclusive bins in each destination @


mfreq[.,1] = fentry-pass50;
mfreq[.,2] = pass50-pass75;
mfreq[.,3] = pass75;


fmfreq[.,1] = fentry-fpass50;
fmfreq[.,2] = fpass50-fpass75;
fmfreq[.,3] = fpass75;


lmfreq[.,1] = fentry-lapass50;
lmfreq[.,2] = lapass50-lapass75;
lmfreq[.,3] = lapass75;

retp(fentry,mfreq,fmfreq,lmfreq,snpay7);

endp;


proc myfunc(x);
   local fentry,mfreq,fmfreq,lmfreq,snpay7,
   ymat1,ymat2,ymat3,ymat4,
   yvec1,yvec2,yvec3,yvec4,yvec,	
   mfrac,fmfrac,lmfrac,snpayfrac,npayfrac;
   tparvec[locest] = x;
   parvec = untrans(tparvec);

  {fentry,mfreq,fmfreq,lmfreq,snpay7} = firmsim; 
  
  mfrac = mfreq./fentry;
  fmfrac = fmfreq./fentry;
  lmfrac = lmfreq./fentry;
  snpayfrac = snpay7/sumc(snpay7);
  npayfrac = npay7/sumc(npay7);

   ymat1 = mfrac - tprob2;
   ymat1 = delif(ymat1,frvec);
   yvec1 = vec(ymat1);

   ymat2 = fmfrac - tprob2;
   ymat2 = delif(ymat2,frvec);
   yvec2 = vec(ymat2);

   ymat3 = lmfrac - tprob2;
   ymat3 = delif(ymat3,frvec);
   yvec3 = vec(ymat3);

   yvec4 = snpayfrac - npayfrac;
   
   yvec = yvec1|yvec2|yvec3|yvec4; 

@    Use weights from inverse first-stage bootstrapped variance covariance matrix loaded above @

myfit = yvec'*ivcmat3*yvec;


   retp(myfit);
endp;



@&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&@

@ use simulated annealing (not amoeba anymore) to minimize the objective function @

@ initialize simplex @


simp=tpar0; 

@ parameters of the simulated annealing prg @

max=0;
rt=.6;  
eps=1.0E-2;
ns=20;
nt=5;
neps=4;
maxevl=15000;
npar=rows(tpar0);

lb={1, 0, 0, -1, 0};
ub={5, 3, 1, 1, 10};
lb = lb[locest];
ub = ub[locest];

c=2*ones(npar,1);

iprint=3;
t=0.1;
vm=1*ones(npar,1);

vm = 1*ones(npar,1);




{tpar1,min,nacc,nfcnev,nobds,ier,t,vm}=sa(&myfunc,tpar0,max,rt,eps,ns,nt,neps,maxevl,lb,ub,c,iprint,t,vm);  


" ";
" the minimized objective function ";
min;


tparvec[locest] = tpar1;
parvec = untrans(tparvec);

@
parvec = parvec0;
@


format /rd 16,4;

" initial and final parameters ";
" (thetatil|sigma_a|sigma_h|rho_ah|lamdatil) "; 

parvec0[1:5]~parvec[1:5];


" ";
" final fit ";
myfit = myfunc(tparvec[locest]);
" myfit = " myfit;


{fentry,mfreq,fmfreq,lmfreq,snpay7} = firmsim; 


frac0050 = mfreq[.,1]./fentry;
frac5075 = mfreq[.,2]./fentry;
frac75up = mfreq[.,3]./fentry;

" ";
" country, French exporters to market,  simulated  ";
call printfmt((cnty~sun1~fentry),(0~1~1));
" ";
" country, simulate fraction exporting below 50th, 50-75, above 75  percentile ";
call printfmt((cnty~frac0050~frac5075~frac75up),(0~1~1~1));
" ";

frac0050 = fmfreq[.,1]./fentry;
frac5075 = fmfreq[.,2]./fentry;
frac75up = fmfreq[.,3]./fentry;

" ";
" country, simulate fraction selling in Franch below 50th, 50-75, above  percentile ";
call printfmt((cnty~frac0050~frac5075~frac75up),(0~1~1~1));
" ";

frac0050 = lmfreq[.,1]./fentry;
frac5075 = lmfreq[.,2]./fentry;
frac75up = lmfreq[.,3]./fentry;

" ";
" country, simulate fraction with export intensity below 50th, 50-75, above 75 percentile ";
call printfmt((cnty~frac0050~frac5075~frac75up),(0~1~1~1));
" ";

" pay7, French firms selling to that set, simulated ";
pay7~npay7~snpay7;
" ";



@procedure simulated annealing sa@

proc (8) = sa(&fcn,x,max,rt,eps,ns,nt,neps,maxevl,lb,ub,c,iprint,t,vm);


/**

GAUSS version of Bill Goffe's simulated annealing program for global
optimization, written by E.G.Tsionas.

  Date: 9/4/95.

  Synopsis:
  This routine implements the continuous simulated annealing global
  optimization algorithm described in Corana et al.'s article
  "Minimizing Multimodal Functions of Continuous Variables with the
  "Simulated Annealing" Algorithm" in the September 1987 (vol. 13,
  no. 3, pp. 262-280) issue of the ACM Transactions on Mathematical
  Software.

  A very quick (perhaps too quick) overview of SA:
     SA tries to find the global optimum of an N dimensional function.
  It moves both up and downhill and as the optimization process
  proceeds, it focuses on the most promising area.
     To start, it randomly chooses a trial point within the step length
  VM (a vector of length N) of the user selected starting point. The
  function is evaluated at this trial point and its value is compared
  to its value at the initial point.
     In a maximization problem, all uphill moves are accepted and the
  algorithm continues from that trial point. Downhill moves may be
  accepted; the decision is made by the Metropolis criteria. It uses T
  (temperature) and the size of the downhill move in a probabilistic
  manner. The smaller T and the size of the downhill move are, the more
  likely that move will be accepted. if the trial is accepted, the
  algorithm moves on from that point. if it is rejected, another point
  is chosen instead for a trial evaluation.
     Each element of VM periodically adjusted so that half of all
  function evaluations in that direction are accepted.
     A fall in T is imposed upon the system with the RT variable by
  T(i+1) = RT*T(i) where i is the ith iteration. Thus, as T declines,
  downhill moves are less likely to be accepted and the percentage of
  rejections rise. Given the scheme for the selection for VM, VM falls.
  Thus, as T declines, VM falls and SA focuses upon the most promising
  area for optimization.

  The importance of the parameter T:
     The parameter T is crucial in using SA successfully. It influences
  VM, the step length over which the algorithm searches for optima. for
  a small intial T, the step length may be too small; thus not enough
  of the function might be evaluated to find the global optima. The user
  should carefully examine VM in the intermediate output (set IPRINT =
  1) to make sure that VM is appropriate. The relationship between the
  initial temperature and the resulting step length is function
  dependent.
     To determine the starting temperature that is consistent with
  optimizing a function, it is worthwhile to run a trial run first. Set
  RT = 1.5 and T = 1.0. With RT > 1.0, the temperature increases and VM
  rises as well. Then select the T that produces a large enough VM.

  for modifications to the algorithm and many details on its use,
  (particularly for econometric applications) see Goffe, Ferrier
  and Rogers, "Global Optimization of Statistical Functions with
  Simulated Annealing," Journal of Econometrics, vol. 60, no. 1/2,
  Jan./Feb. 1994, pp. 65-100.
  for more information, contact
              Bill Goffe
              Department of Economics and International Business
              University of Southern Mississippi
              Hattiesburg, MS  39506-5072
              (601) 266-4484 (office)
              (601) 266-4920 (fax)
              bgoffe@whale.st.usm.edu (Internet)
  for information regarding the present GAUSS version, contact
              E.G. Tsionas
              Department of Economics
              University of Toronto
              150 St George Str.
              Toronto Ontario M5S 1A1
              Canada
              (416) 978 4188 (office)
              (416) 978 6713 (fax)
              etsionas@epas.utoronto.ca (Internet)

  As far as possible, the parameters here have the same name as in
  the description of the algorithm on pp. 266-8 of Corana et al.

  In this description (N) denotes an array of length n.

  Use:
  {xopt, fopt, nacc, nfcnev, nobds, ier, t, vm} =
     sa (&fcn,x,max,rt,eps,ns,nt,neps,maxevl,lb,ub,c,iprint,t,vm);

  Input Parameters:
    Note: The suggested values generally come from Corana et al. To
          drastically reduce runtime, see Goffe et al., pp. 90-1 for
          suggestions on choosing the appropriate RT and NT.
    &fcn - Name of a Gauss procedure which returns the value of function
          to be optimized.
    x - The starting values for the variables of the function to be
        optimized. (N)
    max - Denotes whether the function should be maximized or
          minimized. A value =1 denotes maximization while a
          value =0 denotes minimization. Intermediate output (see IPRINT)
          takes this into account.
    rt - The temperature reduction factor. The value suggested by
         Corana et al. is .85. See Goffe et al. for more advice.
    eps - Error tolerance for termination. if the final function
          values from the last neps temperatures differ from the
          corresponding value at the current temperature by less than
          EPS and the final function value at the current temperature
          differs from the current optimal function value by less than
          EPS, execution terminates and IER = 0 is returned.
    ns - Number of cycles. After NS*N function evaluations, each
         element of VM is adjusted so that approximately half of
         all function evaluations are accepted. The suggested value
         is 20.
    nt - Number of iterations before temperature reduction. After
         NT*NS*N function evaluations, temperature (T) is changed
         by the factor RT. Value suggested by Corana et al. is
         max(100, 5*n). See Goffe et al. for further advice.
    neps - Number of final function values used to decide upon termi-
           nation. See EPS. Suggested value is 4.
    maxevl - The maximum number of function evaluations. if it is
             exceeded, IER = 1.
    lb - The lower bound for the allowable solution variables. (N)
    ub - The upper bound for the allowable solution variables. (N)
         if the algorithm chooses X(I) < LB(I) or X(I) > UB(I),
         I = 1, N, a point is from inside is randomly selected. This
         This focuses the algorithm on the region inside UB and LB.
         Unless the user wishes to concentrate the search to a par-
         ticular region, UB and LB should be set to very large positive
         and negative values, respectively. Note that the starting
         vector X should be inside this region. Also note that LB and
         UB are fixed in position, while VM is centered on the last
         accepted trial set of variables that optimizes the function.
    c - Vector that controls the step length adjustment. The suggested
        value for all elements is 2.0. (N)
    iprint - controls printing inside SA.
             Values: 0 - Nothing printed.
                     1 - Function value for the starting value and
                         summary results before each temperature
                         reduction. This includes the optimal
                         function value found so far, the total
                         number of moves (broken up into uphill,
                         downhill, accepted and rejected), the
                         number of out of bounds trials, the
                         number of new optima found at this
                         temperature, the current optimal X and
                         the step length VM. Note that there are
                         N*NS*NT function evalutations before each
                         temperature reduction. Finally, notice is
                         is also given upon achieveing the termination
                         criteria.
                     2 - Each new step length (VM), the current optimal
                         X (XOPT) and the current trial X (X). This
                         gives the user some idea about how far X
                         strays from XOPT as well as how VM is adapting
                        to the function.
                     3 - Each function evaluation, its acceptance or
                         rejection and new optima. for many problems,
                         this option will likely require a small tree
                         if hard copy is used. This option is best
                         used to learn about the algorithm. A small
                         value for MAXEVL is thus recommended when
                         using IPRINT = 3.
             Suggested value: 1
             Note: for a given value of IPRINT, the lower valued
                   options (other than 0) are utilized.
 c  Input/Output Parameters:
    t - On input, the initial temperature. See Goffe et al. for advice.
        On output, the final temperature.
    vm - The step length vector. On input it should encompass the
         region of interest given the starting value X. for point
         X(I), the next trial point is selected is from X(I) - VM(I)
         to  X(I) + VM(I). Since VM is adjusted so that about half
         of all points are accepted, the input value is not very
         important (i.e. is the value is off, SA adjusts VM to the
         correct value). (N)

  Output Parameters:
    xopt - The variables that optimize the function. (N)
    fopt - The optimal value of the function.
    nacc - The number of accepted function evaluations.
    nfcnev - The total number of function evaluations. In a minor
             point, note that the first evaluation is not used in the
             core of the algorithm; it simply initializes the
             algorithm.
    nobds - The total number of trial function evaluations that
            would have been out of bounds of LB and UB. Note that
            a trial point is randomly selected between LB and UB.

    ier - The error return number.
          Values: 0 - Normal return; termination criteria achieved.
                  1 - Number of function evaluations (NFCNEV) is
                      greater than the maximum number (MAXEVL).
                  2 - The starting value (X) is not inside the
                      bounds (LB and UB).
                  3 - The initial temperature is not positive.
                  99 - Should not be seen; only used internally.


    The statement "#include sa" is necessary in the calling program.
    The random number generator can also be initialized there. for
    example the statement "rndseed 123;" initializes the seed to 123.

  Required procedures (included):
    prt1 ... prt10 - Prints intermediate output.
    fcn - Name of function to be optimized. The form is

            proc fcn(x);
              local f,......;
                        ...
              function code with f = f(x)
                        ...
              retp(f);
            endp;

  Machine Specific Features:
    1. Watch for under- and overflows in EXPREP. EXPREP replaces the exp()
       function of GAUSS and is written for the 386 version.

  Note:
       This version is not completely vectorized.

       You can use this program freely as long as it is for non-commercial,
       academic purposes and the author is credited. No responsibilities for
       the program's actual performance can be assumed.

**/



local n, xopt, xp, nacp, nacc, nobds, nfcnev, ier, fstar,
      f, fopt, nup, nrej, nnew, ndown, lnobds, m, j, h, i,
      fp, p, pp, ratio, quit, fcn:proc;

n = rows(x);
xopt = zeros(n,1);
xp = zeros(n,1);
nacp = zeros(n,1);

/**  Set initial values.**/

nacc = 0;
nobds = 0;
nfcnev = 0;
ier = 99;
xopt = x;
nacp = zeros(n,1);
fstar = 1e20*ones(neps,1);

/** If the initial temperature is not positive, notify the user and abort. **/

if (t <= 0.0);
  print" The initial temperature is not positive. Reset the variable t";
  ier = 3; stop;
endif;

/**  If the initial value is out of bounds, notify the user and abort. **/

if (sumc(x.> ub)+ sumc(x.< lb) > 0);
  print "initial condition out of bounds";
  ier = 2; stop;
endif;

/**  Evaluate the function with input x and return value as f. **/

f = fcn(x);

/**
  if the function is to be minimized, switch the sign of the function.
  Note that all intermediate and final output switches the sign back
  to eliminate any possible confusion for the user.
**/

if (max == 0); f = -f; endif;
nfcnev = nfcnev + 1;
fopt = f;
fstar[1] = f;
if (iprint > 1); call prt2(max,x,f); endif;

/**
  Start the main loop. Note that it terminates if (i) the algorithm
  succesfully optimizes the function or (ii) there are too many
  function evaluations (more than MAXEVL).
**/

_100:   nup = 0;
 nrej = 0;
 nnew = 0;
 ndown = 0;
 lnobds = 0;

      m=1; do while m <= nt;
         j=1; do while j <= ns;
            h=1; do while h <= n;

/**  Generate xp, the trial value of x. Note use of vm to choose xp. **/

               i=1; do while i <= n;
                  if (i == h);
                     xp[i] = x[i] + (rndu(1,1)*2.- 1.) * vm[i];
                  else;
                     xp[i] = x[i];
                  endif;

/**  If xp is out of bounds, select a point in bounds for the trial. **/

 if((xp[i] < lb[i]) or (xp[i] > ub[i]));
     xp[i] = lb[i] + (ub[i] - lb[i])*rndu(1,1);
     lnobds = lnobds + 1;
     nobds = nobds + 1;
     if(iprint >= 3); call prt3(max,xp,x,fp,f); endif;
  endif;
i = i+1; endo;

/**  Evaluate the function with the trial point xp and return as fp. **/

fp = fcn(xp);
if(max == 0); fp = -fp; endif;
nfcnev = nfcnev + 1;
if(iprint >= 3); call prt4(max,xp,x,fp,f); endif;

/**  If too many function evaluations occur, terminate the algorithm. **/

if(nfcnev >= maxevl);
   call prt5();
   if (max == 0); fopt = -fopt; endif;
   ier = 1;
   stop;
endif;

/**  Accept the new point if the function value increases. **/

if (fp >= f);
   if(iprint >= 3);
   print "point accepted";
endif;
x = xp;
f = fp;
nacc = nacc + 1;
nacp[h] = nacp[h] + 1;
nup = nup + 1;

/**  If greater than any other point, record as new optimum. **/

if (fp > fopt);
   if(iprint >= 3); print "new optimum"; endif;
   xopt = xp;
   fopt = fp;
   nnew = nnew + 1;
endif;

/**
 if the point is lower, use the Metropolis criteria to decide on
 acceptance or rejection.
**/

    else;
p = exprep((fp - f)/t);
pp = rndu(1,1);

if (pp < p);
 if(iprint >= 3); call prt6(max); endif;
 x = xp;
 f = fp;
 nacc = nacc + 1;
 nacp[h] = nacp[h] + 1;
 ndown = ndown + 1;
else;
 nrej = nrej + 1;
 if(iprint >= 3); call prt7(max); endif;
endif;
endif;

h = h+1; endo;
j = j+1; endo;

/**  Adjust vm so that approximately half of all evaluations are accepted. **/

i=1; do while i <= n;
   ratio = nacp[i] /ns;
       if (ratio > .6);
          vm[i] = vm[i]*(1. + c[i]*(ratio - .6)/.4);
          elseif (ratio < .4);
          vm[i] = vm[i]/(1. + c[i]*((.4 - ratio)/.4));
        endif;
            if (vm[i] > (ub[i]-lb[i]));
               vm[i] = ub[i] - lb[i];
            endif;
i = i+1; endo;

if(iprint >= 2); call prt8(vm,xopt,x); endif;

nacp = zeros(n,1);

m = m+1; endo;

if(iprint >= 1);
 call prt9(max,t,xopt,vm,fopt,nup,ndown,nrej,lnobds,nnew);
endif;

/**  Check termination criteria. **/

quit = 0;
fstar[1] = f;
if ((fopt - fstar[1]) <= eps); quit = 1; endif;
if ( sumc(abs(f-fstar) .> eps) > 0 ); quit = 0; endif;

/**  Terminate SA if appropriate. **/

  if (quit);
     x = xopt;
     ier = 0;
     if (max == 0); fopt = -fopt; endif;
     if(iprint >= 1); call prt10; endif;
   retp(xopt, fopt, nacc, nfcnev, nobds, ier, t, vm);
  endif;

/**  If termination criteria are not met, prepare for another loop. **/

t = rt*t;
i=neps; do while i >= 2;
  fstar[i] = fstar[i-1];
i = i-1; endo;
f = fopt;
x = xopt;

/**  Loop again. **/
goto _100;
endp;

/**********************************************************************/

proc exprep(x);
/**
  This function replaces exp to avoid under- and overflows.
  Note that the maximum and minimum values of
  exprep are such that they has no effect on the algorithm.
**/

local e;
if (x > 709); e = 8.2184e+307;
   elseif (x < -708); e = 0;
   else; e = exp(x);
endif;
retp(e);
endp;
/**********************************************************************/

proc (0) = prt1();
/**
  This subroutine prints intermediate output, as does prt2 through
  prt10. Note that if SA is minimizing the function, the sign of the
  function value and the directions (up/down) are reversed in all
  output to correspond with the actual function optimization.
**/

print "The starting value (x) is outside the bounds";
print "(lb and ub). execution terminated without any";
print "optimization. Respecify x, ub or lb so that";
print "lb(i) < x(i) < ub(i), i = 1, n";
endp;
/**********************************************************************/

proc (0) =  prt2(max,x,f);
print "";
print "initial x" x;
if (max); print "initial f" f; else; print "initial f" -f; endif;
endp;
/**********************************************************************/

proc (0) =  prt3(max,xp,x,fp,f);
print "";
print "current x"; x;
if (max);
 print "current f" f;
else;
 print "current f" -f;
endif;
print "trial x" xp;
print "point rejected since out of bounds";
endp;
/**********************************************************************/

proc (0) = prt4(max,xp,x,fp,f);
print "";
print "current x" x;
if (max);
 print "current f" f;
 print "trial x" xp;
 print "resulting f" fp;
else;
 print "current f" -f;
 print "trial x" xp;
 print "resulting f" -fp;
endif;
endp;
/**********************************************************************/

proc (0) =  prt5();
print "Too many function evaluations; consider";
print "increasing maxevl or eps, or decreasing";
print "nt or rt. These results are likely to be poor";
endp;
/**********************************************************************/

proc (0) =  prt6(max);
if (max);
 print "though lower, point accepted";
else;
 print "though higher, point accepted";
endif;
endp;
/**********************************************************************/

proc (0) =  prt7(max);
if (max);
 print "lower point rejected";
else;
 print "higher point rejected";
endif;
endp;
/**********************************************************************/

proc (0) =  prt8(vm,xopt,x);

print "intermediate results after step length adjustment";
print "new step length (vm)" vm;
print "current optimal x" xopt;
print "current x" x;
print "";
endp;
/**********************************************************************/

proc (0) = prt9(max,t,xopt,vm,fopt,nup,ndown,nrej,lnobds,nnew);
local totmov;
totmov = nup + ndown + nrej;

print "Intermediate results before next temperature reduction";
print "current temperature   " t;
if (max);
 print "max function value so far" fopt;
 print "total moves" totmov;
 print "uphill" nup;
 print "accepted downhill" ndown;
 print "rejected downhill" nrej;
 print "out of bounds trials" lnobds;
 print "new maxima this temperature" nnew;
else;
 print "min function value so far" -fopt;
 print "total moves" totmov;
 print "downhill" nup;
 print "accepted uphill" ndown;
 print "rejected uphill" nrej;
 print "trials out of bounds"  lnobds;
 print "new minima this temperature"  nnew;
endif;
print "current optimal x" xopt;
print "strength (vm)" vm;
print "";
endp;
/**********************************************************************/

proc (0) = prt10();
print "SA achieved termination criteria. ier = 0";
endp;


end;