new;
cls;

@ CFMOCT14.PRG       @
@  fixed percentiles                           @
@  add statistics on selling to multiple mkts. @
@        @
@ Use new data from Francis (8/20/2007) @
@                                           @
@  Compute implications for productivity    @
@   Use new data from Francis               @
@  Eaton tries to add calculation of intensive and extensive margins @
@                                           @
@    Back out the simgaEn from French entry @
@                                           @
@   Melitz-Chaney case @
@                                                 @ 
@    Account for Exporters being large in France @
@                                                                            @
@ Create set of moments from simulated firms @
@     firms simulated in CFMOC10.PRG @
@     moments used in GMM estimation test @
@     adds breakdown into extensive and intensive margin by country @ 

@ updated on 11/15/2008 @

OUTPUT FILE = c:\kortum\research\EKK\chi1108\cfmoct14.out RESET;


@ PARAMETERS USED TO GENERATE MONTE CARLO DATA @

@  (see CFMOC10.PRG) @

@ It is nice to know the parameters we used to simulate the fake data @


nfirm = 500000;  @ # of artifical firms @

simsize = 10000;    @ # artific. firms per loop, make sure nsimfirm is divisible by simsize @

simlim = nfirm/simsize;


@  Get the parameter values used by cfmoc11.prg @

thetatil = 2.4629; 
sigma_a = 1.6878; 
sigma_h = .3397; 
rho_ah = -0.6477;
lamdatil= 0.9086; 



@ calibrate mygamm based on mfg. value added as a share of mfg. gross production (from UNIDO) @
vashare = .3612913;

@ externally set parameter from prodXXX.prg @

mbar = 1.5059;

mysigma = mbar/(mbar - 1);
mytheta = thetatil*(mysigma - 1);
betavar = mbar*vashare - 1/mytheta;



ncnty = 113;
ncntyfr = 34;

frvec = zeros(ncnty,1);
frvec[ncntyfr] = 1;

@ load counterfactual wage and price changes  (from cfagg10.prg)         @

load wphat = wphat;
wf1 = wphat[.,1];
pf1 = wphat[.,2];

phatfrance = pf1[ncntyfr];

@ evaluate percentiles of sales distribution @
vpercent = {.1,.2,.3,.4,.5,.6,.7,.8,.9,.99,1.0};
vpercent0 = 0|vpercent;

vcnty = seqa(1,1,ncnty);


bigtemp = zeros(1000,rows(vpercent));



" ";
" ******************** ";
" Parameters from firm simulation ";
"thetatil = " thetatil;
"sigma_a = " sigma_a;
"sigma_h = " sigma_h;
"rho_ah = " rho_ah;
"lamdatil = " lamdatil;
" ";
" mysigma = " mysigma;
" mbar = " mbar;
" betavar = " betavar;
" ";
" phatfrance = " phatfrance;
" ";
" nfirm = " nfirm;
" simsize = " simsize;
" ";
" ******************** ";


@ Load data on French firms' export destinations (no data on France as a destination) @

@ list of country names @
let cnty = "AFGHAN" "ALBANIA" "ALGERIA" "ANGOLA" "ARGENTIN" "AUSTRALI" "AUSTRIA" "BANGLADE" "BELGIUML"
"BENIN" "BOLIVIA" "BRAZIL" "BULGARIA" "BURKINAF" "BURUNDI" "CAMEROON" "CANADA" "CENAFREP" 
"CHAD" "CHILE" "CHINA" "COLOMBIA" "COSTAR" "COTEDI" "CUBA" "CZECH" "DENMARK" 
"DOMREP" "ECUADOR" "EGYPT" "ELSALV" "ETHIOPIA" "FINLAND" "FRANCE" "GERMANYE" "GERMANYW" 
"GHANA" "GREECE" "GUATEM" "HONDURAS" "HONGKONG" "HUNGARY" "INDIA" "INDONES" "IRAN" "IRAQ" "IRELAND" "ISRAEL" 
"ITALY" "JAMAICA" "JAPAN" "JORDAN" "KENYA" "KOREAS" "KUWAIT" "LIBERIA" "LIBYA" "MADAGASC" "MALAWI" "MALAYSIA" "MALI" "MAURITAN" "MAURITIU" "MEXICO" "MOROCCO" "MOZAMBIQ" "NEPAL" "NETHERL" "NEWZEAL" 
"NICARAG" "NIGER" "NIGERIA" "NORWAY" "OMAN" "PAKISTAN" "PANAMA" "PAPNEWGU" "PARAGUAY" "PERU" 
"PHILIPP" "PORTUGAL" "ROMANIA" "RWANDA" "SAUDI" "SENEGAL" "SIERRAL" "SINGAPO" "SOMALIA" 
"SOUTHAFR" "SPAIN" "SRILANKA" "SUDAN" "SWEDEN" "SWITZER" "SYRIA" "TAIWAN" "TANZANIA" 
"THAILAND" "TOGO" "TRINTOB" "TUNISIA" "TURKEY" "UGANDA" "UK" "US" "URUGUAY" 
"USSR" "VENEZUEL" "VIETNAM" "YUGOSLAV" "ZAIRE" "ZAMBIA" "ZIMBABWE";

@ list of country names, LEAVING OUT FRANCE @
let cntynofr = "AFGHAN" "ALBANIA" "ALGERIA" "ANGOLA" "ARGENTIN" "AUSTRALI" "AUSTRIA" "BANGLADE" "BELGIUML"
"BENIN" "BOLIVIA" "BRAZIL" "BULGARIA" "BURKINAF" "BURUNDI" "CAMEROON" "CANADA" "CENAFREP" 
"CHAD" "CHILE" "CHINA" "COLOMBIA" "COSTAR" "COTEDI" "CUBA" "CZECH" "DENMARK" 
"DOMREP" "ECUADOR" "EGYPT" "ELSALV" "ETHIOPIA" "FINLAND" "GERMANYE" "GERMANYW" 
"GHANA" "GREECE" "GUATEM" "HONDURAS" "HONGKONG" "HUNGARY" "INDIA" "INDONES" "IRAN" "IRAQ" "IRELAND" "ISRAEL" 
"ITALY" "JAMAICA" "JAPAN" "JORDAN" "KENYA" "KOREAS" "KUWAIT" "LIBERIA" "LIBYA" "MADAGASC" "MALAWI" "MALAYSIA" "MALI" "MAURITAN" "MAURITIU" "MEXICO" "MOROCCO" "MOZAMBIQ" "NEPAL" "NETHERL" "NEWZEAL" 
"NICARAG" "NIGER" "NIGERIA" "NORWAY" "OMAN" "PAKISTAN" "PANAMA" "PAPNEWGU" "PARAGUAY" "PERU" 
"PHILIPP" "PORTUGAL" "ROMANIA" "RWANDA" "SAUDI" "SENEGAL" "SIERRAL" "SINGAPO" "SOMALIA" 
"SOUTHAFR" "SPAIN" "SRILANKA" "SUDAN" "SWEDEN" "SWITZER" "SYRIA" "TAIWAN" "TANZANIA" 
"THAILAND" "TOGO" "TRINTOB" "TUNISIA" "TURKEY" "UGANDA" "UK" "US" "URUGUAY" 
"USSR" "VENEZUEL" "VIETNAM" "YUGOSLAV" "ZAIRE" "ZAMBIA" "ZIMBABWE";



@ French data by country (in $ millions) @

load ekkcnty[113,12] = c:\kortum\research\EKK\chi0708\paysd.raw;

xnf = ekkcnty[.,1]; 
sun1 = ekkcnty[.,2];
ventf50 = ekkcnty[.,3];
ventf75 = ekkcnty[.,4];
ventf95 = ekkcnty[.,5];
vfteb50 = ekkcnty[.,6];
vfteb75 = ekkcnty[.,7];
vfteb95 = ekkcnty[.,8];
lam50 = ekkcnty[.,9];
lam75 = ekkcnty[.,10];
lam95 = ekkcnty[.,11];
mventfrn = ekkcnty[.,12];

@ Data on Firms with negative French Sales (in $ millions) @

load ekkneg[113,2] = c:\kortum\research\EKK\chi0708\paysneg.raw;
sunneg = ekkneg[.,1];
xnfneg = ekkneg[.,2];

fnegsun = sunneg./(sunneg+sun1);
fnegxnf = xnfneg./(xnfneg+xnf);

xnf0 = xnf;

sun1 = sun1 + sunneg;
xnf = xnf + xnfneg;

meanpay = xnf./sun1;

@ Data on firms exporting to each subset of top 7 most popular destinations @

load ekkseqa[128,2] = c:\kortum\research\EKK\chi0708\seqd.raw;
pay7 = ekkseqa[.,1];
npay7 = ekkseqa[.,2];

@ Data on firms selling to k or more destinations @

load ekksexp[110,4] = c:\kortum\research\EKK\chi0708\sexp86.raw;
knum = ekksexp[.,1];
nfirmk = ekksexp[.,2];
mventfrk = ekksexp[.,3];
prodk = ekksexp[.,4];

knum = knum|seqa(111,1,3);
nfirmk = nfirmk|zeros(3,1);
mventfrk = mventfrk|zeros(3,1);
prodk = prodk|zeros(3,1);

@ Simulated Firm dataset, created in MOC7FE9.PRG @

open firmdat = firmdata;   @ sales by country in monte carlo @
open fixcdat = fixcdata;   @ fixed entry cost by country in monte carlo @
open cfirmdat = cfirmdata;   @ counterfactual sales by country in monte carlo @
open cfixcdat = cfixcdata;   @ counterfactual fixed entry cost by country in monte carlo @
open probdat = probdata;  @ probability weight on each monte carlo draw @

@ initialize matrices to store results @

fentry = zeros(ncnty,simlim);
cffentry = zeros(ncnty,simlim);

kentry = zeros(ncnty,simlim);
cfkentry = zeros(ncnty,simlim);

kexact = zeros(ncnty,simlim);
cf1kexact = zeros(ncnty,simlim);
cf2kexact = zeros(ncnty,simlim);
cf3kexact = zeros(ncnty,simlim);
cf4kexact = zeros(ncnty,simlim);
cf5kexact = zeros(ncnty,simlim);
cf6kexact = zeros(ncnty,simlim);
cf7kexact = zeros(ncnty,simlim);
cf8kexact = zeros(ncnty,simlim);
cf9kexact = zeros(ncnty,simlim);
cf10kexact = zeros(ncnty,simlim);

cf25kexact = zeros(ncnty,simlim);
cf50kexact = zeros(ncnty,simlim);
 
dexptot = zeros(1,simlim);
dexptotext = zeros(1,simlim);

sexptot_k = zeros(8,simlim);
exptot_k = zeros(8,simlim);
dexptot_k = zeros(8,simlim);
dexptotext_k = zeros(8,simlim);

countfirm = zeros(1,simlim);
countexport = zeros(1,simlim);
countfrance = zeros(1,simlim);
counttotal = zeros(1,simlim);

f9050 = zeros(1,simlim);
f9950 = zeros(1,simlim);
cf9050 = zeros(1,simlim);
cf9950 = zeros(1,simlim);

cfcountfirm = zeros(1,simlim);
cfcountexport = zeros(1,simlim);
cfcountfrance = zeros(1,simlim);

fsales = zeros(ncnty,simlim);
cffsales = zeros(ncnty,simlim);

ententry = zeros(ncnty,simlim);
exitentry = zeros(ncnty,simlim);
stayentry = zeros(ncnty,simlim);

entsales = zeros(ncnty,simlim);
exitsales = zeros(ncnty,simlim);
staysales = zeros(ncnty,simlim);
staycfsales = zeros(ncnty,simlim);

bottomentry = zeros(ncnty,simlim);
middleentry = zeros(ncnty,simlim);
superentry = zeros(ncnty,simlim);
topentry = zeros(ncnty,simlim);

bottomcfentry = zeros(ncnty,simlim);
middlecfentry = zeros(ncnty,simlim);
supercfentry = zeros(ncnty,simlim);
topcfentry = zeros(ncnty,simlim);

bottomsales = zeros(ncnty,simlim);
middlesales = zeros(ncnty,simlim);
supersales = zeros(ncnty,simlim);
topsales = zeros(ncnty,simlim);

bottomcfsales = zeros(ncnty,simlim);
middlecfsales = zeros(ncnty,simlim);
supercfsales = zeros(ncnty,simlim);
topcfsales = zeros(ncnty,simlim);

bottomsentry = zeros(ncnty,simlim);
middlesentry = zeros(ncnty,simlim);
supersentry = zeros(ncnty,simlim);
topsentry = zeros(ncnty,simlim);

bottomscfentry = zeros(ncnty,simlim);
middlescfentry = zeros(ncnty,simlim);
superscfentry = zeros(ncnty,simlim);
topscfentry = zeros(ncnty,simlim);

bottomssales = zeros(ncnty,simlim);
middlessales = zeros(ncnty,simlim);
superssales = zeros(ncnty,simlim);
topssales = zeros(ncnty,simlim);

bottomscfsales = zeros(ncnty,simlim);
middlescfsales = zeros(ncnty,simlim);
superscfsales = zeros(ncnty,simlim);
topscfsales = zeros(ncnty,simlim);

salescat = zeros(rows(vpercent0),simlim);
cfsalescat = zeros(rows(vpercent0),simlim);
esalescat = zeros(rows(vpercent0),simlim);
cfesalescat = zeros(rows(vpercent0),simlim);
firmscat = zeros(rows(vpercent0),simlim);
cffirmscat = zeros(rows(vpercent0),simlim);
efirmscat = zeros(rows(vpercent0),simlim);
cfefirmscat = zeros(rows(vpercent0),simlim);


@ Loop through, calculating statistics for simsize firms each time @
i = 1;
do while i <= simlim;

   xmat = readr(firmdat,simsize);
   smat = xmat .gt 0;
   esmat = (delif(smat',frvec))';
   exmat = (delif(xmat',frvec))';

   fcmat = readr(fixcdat,simsize);
   cfxmat = readr(cfirmdat,simsize);
   cfsmat = cfxmat .gt 0;
   cfesmat = (delif(cfsmat',frvec))';
   cfexmat = (delif(cfxmat',frvec))';

   cffcmat = readr(cfixcdat,simsize);
   pubarbar = readr(probdat,simsize);

   @ deflate counterfactual sales and fixed costs ... @
   @ ...  by the general-equilibrium counterfactual price change @
 
   cfxmat = cfxmat/phatfrance;
   cffcmat = cffcmat/phatfrance;
   cfexmat = cfexmat/phatfrance;
     
   @  ************************************************* @
   @                                                    @
   @        Calculate statistics on simsize firms        @
   @                                                    @
   @  ************************************************* @   

   @ Correct for over sampling of high cost firms @
   
   xmat2 = pubarbar.*xmat;
   fcmat2 = pubarbar.*fcmat;
   smat2 = pubarbar.*smat;
   esmat2 = pubarbar.*esmat;

   cfxmat2 = pubarbar.*cfxmat;
   cffcmat2 = pubarbar.*cffcmat;
   cfsmat2 = pubarbar.*cfsmat;
   cfesmat2 = pubarbar.*cfesmat;


   fentry[.,i] = meanc(smat2);    @ Number of "actual" French firms selling in each country @
   cffentry[.,i] = meanc(cfsmat2);    @ Number of "counterfactual" French firms selling in each country @

   dexmat = cfexmat - exmat;
   dexptot2 = pubarbar.*sumc(dexmat');
   dexmatext = (cfesmat - esmat).*dexmat;
   dexptotext2 = pubarbar.*sumc(dexmatext'); 
   
   dexptot[.,i] = meanc(dexptot2);
   dexptotext[.,i] = meanc(dexptotext2);

   temp = pubarbar.*(sumc(smat') .> 0);
   countfirm[i] = meanc(temp);
   temp = pubarbar.*(sumc(cfsmat') .> 0);
   cfcountfirm[i] = meanc(temp);
   temp = pubarbar.*(sumc(esmat') .> 0);
   countexport[i] = meanc(temp);
   temp = pubarbar.*(sumc(cfesmat') .> 0);
   cfcountexport[i] = meanc(temp);
   temp = pubarbar.*(smat[.,ncntyfr] .> 0);
   countfrance[i] = meanc(temp);
   temp = pubarbar.*(cfsmat[.,ncntyfr] .> 0);
   cfcountfrance[i] = meanc(temp);
   counttotal[i] = meanc(pubarbar);

   knum = sumc(esmat');            @ Number of export destinations @
   cfknum = sumc(cfesmat');  

   knummat = (knum.==0)~(knum.==1)~(knum.==2)~(knum.==3)~(knum.==4)~((knum.>=5).*(knum.<=9))~((knum.>=10).*(knum.<=24))~(knum.>=25); 
   

   sexptot2_k = pubarbar.*knummat.*(sumc(smat') .> 0);
   exptot2_k = pubarbar.*sumc(exmat').*knummat;
   dexptot2_k = pubarbar.*sumc(dexmat').*knummat;
   dexptotext2_k = pubarbar.*sumc(dexmatext').*knummat; 

   sexptot_k[.,i] = meanc(sexptot2_k);
   exptot_k[.,i] = meanc(exptot2_k);
   dexptot_k[.,i] = meanc(dexptot2_k);
   dexptotext_k[.,i] = meanc(dexptotext2_k);

   kmore = knum .>= vcnty';   @ # entering k or more export mkts @
   cfkmore = cfknum .>= vcnty';
  
   kmore2 = pubarbar.*kmore;
   cfkmore2 = pubarbar.*cfkmore;

   kentry[.,i] = meanc(kmore2);
   cfkentry[.,i] = meanc(cfkmore2);
  
   kexact2 = pubarbar.*(knum .== vcnty');       @ exporting to exactly k @
   cf1kexact2 = pubarbar.*(knum .== 1).*(cfknum .== vcnty');   @ selling to 1 now and exactly k later @ 
   cf2kexact2 = pubarbar.*(knum .== 2).*(cfknum .== vcnty');   @ selling to 2 now and exactly k later @    
   cf3kexact2 = pubarbar.*(knum .== 3).*(cfknum .== vcnty');
   cf4kexact2 = pubarbar.*(knum .== 4).*(cfknum .== vcnty');
   cf5kexact2 = pubarbar.*(knum .== 5).*(cfknum .== vcnty');
   cf6kexact2 = pubarbar.*(knum .== 6).*(cfknum .== vcnty');
   cf7kexact2 = pubarbar.*(knum .== 7).*(cfknum .== vcnty');
   cf8kexact2 = pubarbar.*(knum .== 8).*(cfknum .== vcnty');
   cf9kexact2 = pubarbar.*(knum .== 9).*(cfknum .== vcnty');
   cf10kexact2 = pubarbar.*(knum .== 10).*(cfknum .== vcnty');

   cf25kexact2 = pubarbar.*(knum .== 25).*(cfknum .== vcnty');
   cf50kexact2 = pubarbar.*(knum .== 50).*(cfknum .== vcnty');

   kexact[.,i] = meanc(kexact2);
   cf1kexact[.,i] = meanc(cf1kexact2);
   cf2kexact[.,i] = meanc(cf2kexact2);
   cf3kexact[.,i] = meanc(cf3kexact2);
   cf4kexact[.,i] = meanc(cf4kexact2);
   cf5kexact[.,i] = meanc(cf5kexact2);
   cf6kexact[.,i] = meanc(cf6kexact2);
   cf7kexact[.,i] = meanc(cf7kexact2);
   cf8kexact[.,i] = meanc(cf8kexact2);
   cf9kexact[.,i] = meanc(cf9kexact2);
   cf10kexact[.,i] = meanc(cf10kexact2);
  
   cf25kexact[.,i] = meanc(cf25kexact2);
   cf50kexact[.,i] = meanc(cf50kexact2);

   @ actual French sales by market, should match data by Law of Large Numbers @
   fsales[.,i] = meanc(xmat2);    

   @ counterfactual French sales by market, should match data by Law of Large Numbers @
   cffsales[.,i] = meanc(cfxmat2); 

   @ separate firm country sales and entry observations by entry, exit, or staying @ 

   enterer = (smat2.==0).*(cfsmat2.>0);
   exiter = (smat2.>0).*(cfsmat2.==0);
   stayer = (smat2.>0).*(cfsmat2.>0);
   
   entsmat = cfsmat2.*enterer; 
   exitsmat = smat2.*exiter;
   staysmat = smat2.*stayer;

   ententry[.,i] = meanc(entsmat);
   exitentry[.,i] = meanc(exitsmat);
   stayentry[.,i] = meanc(staysmat);
      
   entxmat = cfxmat2.*enterer; 
   exitxmat = xmat2.*exiter;
   stayxmat = xmat2.*stayer;
   staycfxmat = cfxmat2.*stayer;

   entsales[.,i] = meanc(entxmat);
   exitsales[.,i] = meanc(exitxmat);
   staysales[.,i] = meanc(stayxmat);
   staycfsales[.,i] = meanc(staycfxmat);

   @ separate firms by initial level of sales in that market @

   bottom = (xmat.>0).*(xmat.<=vfteb50');
   middle = (xmat.>vfteb50').*(xmat.<=vfteb75');
   super = (xmat.>vfteb75').*(xmat.<=vfteb95');
   top = (xmat.>vfteb95');
   
   bottomsmat = smat2.*bottom; 
   middlesmat = smat2.*middle;
   supersmat = smat2.*super;
   topsmat = smat2.*top;

   bottomcfsmat = cfsmat2.*bottom; 
   middlecfsmat = cfsmat2.*middle;
   supercfsmat = cfsmat2.*super;
   topcfsmat = cfsmat2.*top;

   bottomentry[.,i] = meanc(bottomsmat);
   middleentry[.,i] = meanc(middlesmat);
   superentry[.,i] = meanc(supersmat);
   topentry[.,i] = meanc(topsmat);

   bottomcfentry[.,i] = meanc(bottomcfsmat);
   middlecfentry[.,i] = meanc(middlecfsmat);
   supercfentry[.,i] = meanc(supercfsmat);
   topcfentry[.,i] = meanc(topcfsmat);
   
   bottomxmat = xmat2.*bottom; 
   middlexmat = xmat2.*middle;
   superxmat = xmat2.*super;
   topxmat = xmat2.*top;

   bottomcfxmat = cfxmat2.*bottom; 
   middlecfxmat = cfxmat2.*middle;
   supercfxmat = cfxmat2.*super;
   topcfxmat = cfxmat2.*top;
   
   bottomsales[.,i] = meanc(bottomxmat);
   middlesales[.,i] = meanc(middlexmat);
   supersales[.,i] = meanc(superxmat);
   topsales[.,i] = meanc(topxmat);
   
   bottomcfsales[.,i] = meanc(bottomcfxmat);
   middlecfsales[.,i] = meanc(middlecfxmat);
   supercfsales[.,i] = meanc(supercfxmat);
   topcfsales[.,i] = meanc(topcfxmat);

  @ isolate stayers by initial level of sales in that market @
 
   bottoms = bottom.*stayer;
   middles = middle.*stayer;
   supers = super.*stayer;
   tops = top.*stayer;

   bottomssmat = smat2.*bottoms; 
   middlessmat = smat2.*middles;
   superssmat = smat2.*supers;
   topssmat = smat2.*tops;

   bottomscfsmat = cfsmat2.*bottoms; 
   middlescfsmat = cfsmat2.*middles;
   superscfsmat = cfsmat2.*supers;
   topscfsmat = cfsmat2.*tops;

   bottomsentry[.,i] = meanc(bottomssmat);
   middlesentry[.,i] = meanc(middlessmat);
   supersentry[.,i] = meanc(superssmat);
   topsentry[.,i] = meanc(topssmat);

   bottomscfentry[.,i] = meanc(bottomscfsmat);
   middlescfentry[.,i] = meanc(middlescfsmat);
   superscfentry[.,i] = meanc(superscfsmat);
   topscfentry[.,i] = meanc(topscfsmat);
   
   bottomsxmat = xmat2.*bottoms; 
   middlesxmat = xmat2.*middles;
   supersxmat = xmat2.*supers;   
   topsxmat = xmat2.*tops;

   bottomscfxmat = cfxmat2.*bottoms; 
   middlescfxmat = cfxmat2.*middles;
   superscfxmat = cfxmat2.*supers;   
   topscfxmat = cfxmat2.*tops;
   
   bottomssales[.,i] = meanc(bottomsxmat);
   middlessales[.,i] = meanc(middlesxmat);
   superssales[.,i] = meanc(supersxmat);
   topssales[.,i] = meanc(topsxmat);
   
   bottomscfsales[.,i] = meanc(bottomscfxmat);
   middlescfsales[.,i] = meanc(middlescfxmat);
   superscfsales[.,i] = meanc(superscfxmat);
   topscfsales[.,i] = meanc(topscfxmat);

   @ total sales of each firm @
   xtot = sumc(xmat');
   xtot2 = pubarbar.*xtot;
   xfr = xmat[.,ncntyfr];
   xfr2 = pubarbar.*xfr;
   xx = xtot - xfr;
   xx2 = pubarbar.*xx;
 
   cfxtot = sumc(cfxmat');
   cfxtot2 = pubarbar.*cfxtot;
   cfxfr = cfxmat[.,ncntyfr];
   cfxfr2 = pubarbar.*cfxfr;
   cfxx = cfxtot - cfxfr;
   cfxx2 = pubarbar.*cfxx;

   stot = (sumc(smat') .> 0);
   stot2 = pubarbar.*stot;
   sx = (sumc(esmat') .> 0);
   sx2 = pubarbar.*sx;

   cfstot = (sumc(cfsmat') .> 0);
   cfstot2 = pubarbar.*cfstot;
   cfsx = (sumc(cfesmat') .> 0);
   cfsx2 = pubarbar.*cfsx;



   @ percentiles of total (factual) sales @

   fmat = xtot~pubarbar;
   fmat = selif(fmat,xtot .> 0);
   sfmat = sortc(fmat,1);          @ smallest to largest @
   temp = cumsumc(sfmat[.,2]);
   temp = temp/temp[rows(temp)];
   temploc = sumc(temp .<= vpercent');
   temploc = maxc((temploc~ones(rows(temploc),1))');
   percenti = sfmat[temploc,1];
   percenti = (-1)|0|percenti;

f9050[.,i] = percenti[11]/percenti[7];   
f9950[.,i] = percenti[12]/percenti[7];

   @ condition on the firm's initial size @   
   
   v =    1;
   do while v < rows(percenti);
       temp = (xtot .> percenti[v]).*(xtot .<= percenti[v+1]);
              
       salescat[v,i] = meanc(pubarbar.*temp.*xtot);       
       cfsalescat[v,i] = meanc(pubarbar.*temp.*cfxtot);       
       esalescat[v,i] = meanc(pubarbar.*temp.*xx);       
       cfesalescat[v,i] = meanc(pubarbar.*temp.*cfxx);       
     
       firmscat[v,i] = meanc(pubarbar.*temp.*stot);       
       cffirmscat[v,i] = meanc(pubarbar.*temp.*cfstot);       
       efirmscat[v,i] = meanc(pubarbar.*temp.*sx);       
       cfefirmscat[v,i] = meanc(pubarbar.*temp.*cfsx);       

       v = v+1;
   endo;




@ calculate percentiles of counterfactual sales @

   fmat = cfxtot~pubarbar;
   fmat = selif(fmat,cfxtot .> 0);
   sfmat = sortc(fmat,1); @ smallest to largest @
   temp = cumsumc(sfmat[.,2]);
   temp = temp/temp[rows(temp)];
   temploc = sumc(temp .< vpercent');
   temploc = maxc((temploc~ones(rows(temploc),1))');
   cfpercenti = sfmat[temploc,1];
   cfpercenti = 0|cfpercenti;

cf9050[.,i] = cfpercenti[10]/cfpercenti[6];
cf9950[.,i] = cfpercenti[11]/cfpercenti[6];
 
@ isolate enterers @ 

   fmat = cfxtot~pubarbar;
   fmat = selif(fmat,cfxtot .> 0);
   cfpubar = sumc(fmat[.,2]);
   
   temp = (xtot .== 0);
   cfxt = cfxtot~pubarbar; 
   enter = selif(cfxt,temp);
   
   cfpuentry = sumc(enter[.,2]);
   cffrentry = cfpuentry/cfpubar;
  
   enterfr = selif(cfxfr,temp);
   nenter = sumc(enter[.,2])/20000;
   
   v = 1;
       do while v < rows(cfpercenti);
       temp = (enter[.,1] .> cfpercenti[v]).*(enter[.,1] .<= cfpercenti[v+1]);
       emptytag = sumc(temp);
       if emptytag > 0;        
            enterv = selif(enter,temp);
            putop = sumc(enterv[.,2]);
          pubottom = sumc(enter[.,2]);
          puentv = putop./pubottom;
       else;
          vpercent[v]~0;
       endif;
       v = v+1;
    endo;

    i = i + 1;
endo;

closeall;

@ avoid zeros @

fentry = meanc(fentry') ;   
kentry = meanc(kentry') ;
fsales = meanc(fsales') ;

f9050 = meanc(f9050');
f9950 = meanc(f9950');
cf9050 = meanc(cf9050');
cf9950 = meanc(cf9950');

dexptot = meanc(dexptot') ;
dexptotext = meanc(dexptotext') ;
sexptot_k = meanc(sexptot_k') ;
exptot_k = meanc(exptot_k') ;
dexptot_k = meanc(dexptot_k') ;
dexptotext_k = meanc(dexptotext_k') ;

cffentry = meanc(cffentry') ;   
cfkentry = meanc(cfkentry') ;   
cffsales = meanc(cffsales') ;

countfirm = meanc(countfirm');
cfcountfirm = meanc(cfcountfirm');
countexport = meanc(countexport');
cfcountexport = meanc(cfcountexport');
countfrance = meanc(countfrance');
cfcountfrance = meanc(cfcountfrance');
counttotal = meanc(counttotal');

dcountfirm = cfcountfirm - countfirm;
pdcountfirm = 100*dcountfirm/countfirm;
dcountexport = cfcountexport - countexport;
pdcountexport = 100*dcountexport/countexport;
dcountfrance = cfcountfrance - countfrance;
pdcountfrance = 100*dcountfrance/countfrance;


kexact = meanc(kexact') ;
cf1kexact = meanc(cf1kexact') ;
cf2kexact = meanc(cf2kexact') ;
cf3kexact = meanc(cf3kexact') ;
cf4kexact = meanc(cf4kexact') ;
cf5kexact = meanc(cf5kexact') ;
cf6kexact = meanc(cf6kexact') ;
cf7kexact = meanc(cf7kexact') ;
cf8kexact = meanc(cf8kexact') ;
cf9kexact = meanc(cf9kexact') ;
cf10kexact = meanc(cf10kexact') ;
cf25kexact = meanc(cf25kexact') ;
cf50kexact = meanc(cf50kexact') ;

dentry = cffentry - fentry;
dsales = cffsales - fsales;
pdentry = 100*dentry./fentry;
pdsales = 100*dsales./fsales;


" ***** ";
"  ";
"  country, dentry, pdentry, dsales, pdsales ";
call printfmt((cnty~dentry~pdentry~dsales~pdsales),(0~1~1~1~1));
" ";

totsales = sumc(fsales);
dtotsales = sumc(dsales);
pdtotsales = 100*dtotsales/totsales;

" baseline total sales = " totsales;
" change in total sales = " dtotsales;
" percentage change = " pdtotsales;
" ";

totexports = totsales - fsales[ncntyfr];
dtotexports = dtotsales - dsales[ncntyfr];
pdtotexports = 100*dtotexports/totexports;


" baseline total exports = " totexports;
" change in total sales = " dtotexports;
" percentage change = " pdtotexports;
" ";
" ";
" number of firms that ever appear = " counttotal;
" ";
" baseline number of firms = " countfirm;
" change in number of firms = " dcountfirm;
" percentage change in number of firms = " pdcountfirm;
" ";
" baseline number of exporter = " countexport;
" change in number of exporters = " dcountexport;
" percentage change in number of exporters = " pdcountexport;
" ";
" baseline number selling in France = " countfrance;
" change in number selling in France = " dcountfrance;
" percentage change in number selling in France = " pdcountfrance;
" ";
" ";
" ratio of 90th to 50th percentile, baseline and counterfactual ";
" f9050 = " f9050;
" cf9050 = " cf9050;
" ";
" ratio of 99th to 50th percentile, baseline and counterfactual ";
" f9950 = " f9950;
" cf9950 = " cf9950;
" ";
" ";
ententry = meanc(ententry') ;   
exitentry = meanc(exitentry') ;
stayentry = meanc(stayentry') ;   

entsales = meanc(entsales') ;   
exitsales = meanc(exitsales') ;
staysales = meanc(staysales') ;   
staycfsales = meanc(staycfsales') ;

dstaysales = staycfsales - staysales;

entsshare = entsales./dsales;
exitsshare = -exitsales./dsales;
staysshare = dstaysales./dsales;
totsshare = entsshare + exitsshare + staysshare;

@
"  ";
"  ";
"  total sales share (should equal one) ";
call printfmt((cnty~totsshare),(0~1));
@

@ terms for sizes of enterers, exiters, and stayers @

@ average sales per firm @

afsales = fsales./fentry;
cfafsales = cffsales./cffentry;

aentsales = entsales./ententry;
aexitsales = exitsales./exitentry;

relentsize = aentsales./afsales;
relexitsize = aexitsales./afsales;

@ terms for growth decomposition by destination @

gdenom = (fsales + cffsales)/2;
tgrowth = dsales./gdenom;
staydenom = (staysales + staycfsales)/2;
stayshare = staydenom./gdenom;
staygrowth = dstaysales./staydenom;
entrycont = entsales./gdenom;
exitcont = -exitsales./gdenom;
bigentry = (ententry.*afsales)./gdenom;
bigexit = -(exitentry.*afsales)./gdenom;
entryfix = (entsales - ententry.*afsales)./gdenom;
exitfix = -(exitsales - exitentry.*afsales)./gdenom;

check1 = stayshare.*staygrowth + entrycont + exitcont;
check2 = stayshare.*staygrowth + bigentry + bigexit + entryfix + exitfix;

@
"  ";
"  ";
"  country growth check1 check2 (should all be the same) ";
call printfmt((cnty~tgrowth~check1~check2),(0~1~1~1));
@

@ terms for growth by initial size in that market @

bottomentry = meanc(bottomentry') ;
middleentry = meanc(middleentry') ;
superentry = meanc(superentry') ;
topentry = meanc(topentry') ;

bottomcfentry = meanc(bottomcfentry') ;
middlecfentry = meanc(middlecfentry') ;
supercfentry = meanc(supercfentry') ;
topcfentry = meanc(topcfentry') ;

bottomsales = meanc(bottomsales') ;
middlesales = meanc(middlesales') ;
supersales = meanc(supersales') ;
topsales = meanc(topsales') ;

bottomcfsales = meanc(bottomcfsales') ;
middlecfsales = meanc(middlecfsales') ;
supercfsales = meanc(supercfsales') ;
topcfsales = meanc(topcfsales') ;

bottomsentry = meanc(bottomsentry') ;
middlesentry = meanc(middlesentry') ;
supersentry = meanc(supersentry') ;
topsentry = meanc(topsentry') ;

bottomscfentry = meanc(bottomscfentry') ;
middlescfentry = meanc(middlescfentry') ;
superscfentry = meanc(superscfentry') ;
topscfentry = meanc(topscfentry') ;

bottomssales = meanc(bottomssales') ;
middlessales = meanc(middlessales') ;
superssales = meanc(superssales') ;
topssales = meanc(topssales') ;

bottomscfsales = meanc(bottomscfsales') ;
middlescfsales = meanc(middlescfsales') ;
superscfsales = meanc(superscfsales') ;
topscfsales = meanc(topscfsales') ;

@ some statistics on growth at different levels of initial sales @

bottomdenom = (bottomcfsales + bottomsales)/2;
middledenom = (middlecfsales + middlesales)/2;
superdenom = (supercfsales + middlesales)/2;
topdenom = (topcfsales + topsales)/2;

bottomgrowth = (bottomcfsales - bottomsales)./bottomdenom;
middlegrowth = (middlecfsales - middlesales)./middledenom;
supergrowth = (supercfsales - supersales)./superdenom;
topgrowth = (topcfsales - topsales)./topdenom;

bottomsdenom = (bottomscfsales + bottomssales)/2;
middlesdenom = (middlescfsales + middlessales)/2;
supersdenom = (superscfsales + superssales)./2;
topsdenom = (topscfsales + topssales)/2;

bottomsgrowth = (bottomscfsales - bottomssales)./bottomsdenom;
middlesgrowth = (middlescfsales - middlessales)./middlesdenom;
supersgrowth = (superscfsales - superssales)./supersdenom;
topsgrowth = (topscfsales - topssales)./topsdenom;

@ growth decomposition for stayers by initial sales @

bottomsshare = bottomsdenom./staydenom;
middlesshare = middlesdenom./staydenom;
supersshare = supersdenom./staydenom;
topsshare = topsdenom./staydenom;

bottomscont = bottomsshare.*bottomsgrowth;
middlescont = middlesshare.*middlesgrowth;
superscont = supersshare.*supersgrowth;
topscont =  topsshare.*topsgrowth;



salescat = meanc(salescat');
cfsalescat = meanc(cfsalescat');
esalescat = meanc(esalescat');
cfesalescat = meanc(cfesalescat');

firmscat = meanc(firmscat');
cffirmscat = meanc(cffirmscat');
efirmscat = meanc(efirmscat');
cfefirmscat = meanc(cfefirmscat');


dsalescat = cfsalescat - salescat;
pdsalescat = 100*dsalescat./salescat;

desalescat = cfesalescat - esalescat;
pdesalescat = 100*desalescat./esalescat;

dfirmscat = cffirmscat - firmscat;
pdfirmscat = 100*dfirmscat./firmscat;

defirmscat = cfefirmscat - efirmscat;
pdefirmscat = 100*defirmscat./efirmscat;

" ";
" Total Sales ";
" vpercent, baseline, change, % change ";
(vpercent0~salescat~dsalescat~pdsalescat);
" associated totals ";
(sumc(salescat~dsalescat))';
" ";
" ";
" Exports ";
" vpercent, baseline, change, % change ";
(vpercent0~esalescat~desalescat~pdesalescat);
" associated totals ";
(sumc(esalescat~desalescat))';
" ";

" ";
" All Firms ";
" vpercent, baseline, change, % change ";
(vpercent0~firmscat~dfirmscat~pdfirmscat);
" associated totals ";
(sumc(firmscat~dfirmscat))';
" ";
" ";
" Exporters ";
" vpercent, baseline, change, % change ";
(vpercent0~efirmscat~defirmscat~pdefirmscat);
" associated totals ";
(sumc(efirmscat~defirmscat))';
" ";
" ";

"  ";
"   ***********************  ";
"growth decomposition terms ";
"   ***********************  ";
"  ";
"  ";
"   country, growth, stayer share, stayer growth";
call printfmt((cnty~tgrowth~stayshare~staygrowth),(0~1~1~1));
"  ";
"  ";
"   country, growth, contribution of entry and exit (ignore except for France)";
call printfmt((cnty~tgrowth~entrycont~exitcont),(0~1~1~1));
"  ";
"  ";
"   country, growth, bigentry entryfix (ignore for France)";
call printfmt((cnty~tgrowth~bigentry~entryfix),(0~1~1~1));
"  ";
"  ";
"   country, growth, bigexit exitfix (just for France)";
call printfmt((cnty~tgrowth~bigexit~exitfix),(0~1~1~1));
"  ";


" ";
" country, Number of French exporters to market,  simulated  ";
call printfmt((cnty~sun1~fentry~cffentry),(0~1~1~1));
" ";
" ";
" country, Mean sales in the market,  simulated  ";
call printfmt((cnty~meanpay~afsales~cfafsales),(0~1~1~1));

dsalesnf = delif(dsales,frvec);
entsalesnf = delif(entsales,frvec);
exitsalesnf = delif(exitsales,frvec);
sumchange = sumc(dsalesnf);
sumentry = sumc(entsalesnf);
sumexit = sumc(exitsalesnf);
"  ";
"  ";
" change in total exports, change due to entry exit and stayers ";
sumchange~sumentry~sumexit;  

entshare = 100*entsales./dsales;
exitshare = exitsales./dsales;
stayshare = dstaysales./dsales;
" ";
" ";
" country, change in sales, change due to entry, change due to stayers";
call printfmt((cnty~dsales~entshare~stayshare),(0~1~1~1));


" ";
" ";
" country, change in sales, change due to exit, change do to stayers";
call printfmt((cnty~dsales~exitshare~stayshare),(0~1~1~1));
" ";
" ";
" sources of sales change "; 
" country, entry share, exit share, stayers share ";
call printfmt((cnty~entsshare~exitsshare~staysshare),(0~1~1~1));
" ";
" ";
" relative size of entrant or exiter (ignore second except for France) "; 
" country, relative size of: entrant, exiter";
call printfmt((cnty~relentsize~relexitsize),(0~1~1));
" ";

"  ";
"   ***********************  ";
"growth decompositions by initial size in market ";
"   ***********************  ";
"  ";
"  ";
"  ";
"  ";
" growth by initial sales (all firms present at the beginning)  ";
" country bottom half, middle to top quarter, top 5 percent  ";
call printfmt((cnty~bottomgrowth~middlegrowth~topgrowth),(0~1~1~1));
"  ";
" growth by initial sales (all firms present at the beginning)  ";
" bottom half, middle to top quarter, 75 to 95 percentile, top 5 percent  ";
call printfmt((bottomgrowth~middlegrowth~supergrowth~topgrowth),(1~1~1~1));
"  ";
"  ";
" growth by initial sales conditional on staying  ";
" bottom half, middle to top quarter, 75 to 95 percentile, top 5 percent  ";
call printfmt((bottomsgrowth~middlesgrowth~supersgrowth~topsgrowth),(1~1~1~1));
"  ";
"  ";
" growth decomposition for stayers ";

"  ";
" bottoms ";
" stayers growth, bottoms' share, bottoms' growth ";
call printfmt((cnty~staygrowth~bottomsshare~bottomsgrowth),(0~1~1~1));
"  ";
"  ";
" middles ";
" stayers growth, middles' share, middles' growth ";
call printfmt((cnty~staygrowth~middlesshare~middlesgrowth),(0~1~1~1));
"  ";
"  ";
" supers ";
" stayers growth, supers' share, supers' growth ";
call printfmt((cnty~staygrowth~supersshare~supersgrowth),(0~1~1~1));
"  ";
"  ";
" tops ";
" stayers growth, tops' share, tops' growth ";
call printfmt((cnty~staygrowth~topsshare~topsgrowth),(0~1~1~1));

" ";
"  Selling to Multiple Markets ";
" ";
dkentry = (cfkentry-kentry);
" vcnty, kentry, cfkentry, dkentry ";
vcnty~kentry~cfkentry~dkentry;
" ";
" ";
gkentry = (cfkentry-kentry)./kentry;
" vcnty, kentry, cfkentry, gkentry ";
vcnty~kentry~cfkentry~gkentry;
" ";
" ";
" vcnty, kexact, cf1kexact, cf2kexact ";
vcnty~kexact~cf1kexact~cf2kexact;
" ";
" ";
" vcnty, kexact, cf3kexact, cf4kexact ";
vcnty~kexact~cf3kexact~cf4kexact;
" ";
" ";
" vcnty, kexact, cf25kexact, cf50kexact ";
vcnty~kexact~cf25kexact~cf50kexact;
" ";
temp = zeros(ncnty,1);
temp[1] = sumc(cf1kexact[2:ncnty].*seqa(1,1,(ncnty-1)))/kexact[1]; 
temp[2] = sumc(cf2kexact[3:ncnty].*seqa(1,1,(ncnty-2)))/(2*kexact[2]); 
temp[3] = sumc(cf3kexact[4:ncnty].*seqa(1,1,(ncnty-3)))/(3*kexact[3]); 
temp[4] = sumc(cf4kexact[5:ncnty].*seqa(1,1,(ncnty-4)))/(4*kexact[4]); 
temp[5] = sumc(cf5kexact[6:ncnty].*seqa(1,1,(ncnty-5)))/(5*kexact[5]); 
temp[6] = sumc(cf6kexact[7:ncnty].*seqa(1,1,(ncnty-6)))/(6*kexact[6]); 
temp[7] = sumc(cf7kexact[8:ncnty].*seqa(1,1,(ncnty-7)))/(7*kexact[7]); 
temp[8] = sumc(cf8kexact[9:ncnty].*seqa(1,1,(ncnty-8)))/(8*kexact[8]); 
temp[9] = sumc(cf9kexact[10:ncnty].*seqa(1,1,(ncnty-9)))/(9*kexact[9]); 
temp[10] = sumc(cf10kexact[11:ncnty].*seqa(1,1,(ncnty-10)))/(10*kexact[10]);

temp[25] = sumc(cf25kexact[26:ncnty].*seqa(1,1,(ncnty-25)))/(25*kexact[25]);
temp[50] = sumc(cf50kexact[51:ncnty].*seqa(1,1,(ncnty-50)))/(50*kexact[50]);
" ";
temp;

" ";
" dexptotext " dexptotext;
" ";
" dexptot " dexptot;
" ";
" ratio " (dexptotext/dexptot);
" ";
" ";
" Originally selling to 0, 1, 2, 3, 4, 5-9, 10-24, or >= 25 ";
" ";
vkvec = {0, 1, 2, 3, 4, 5, 10, 25};
" ";
" vkvec, sexptot_k, exptot_k, dexptot_k, (100*dexptot_k./exptot_k), (100*dexptotext_k./depxptot_k) ";
(vkvec~sexptot_k~exptot_k~dexptot_k~(100*dexptot_k./exptot_k)~(100*dexptotext_k./dexptot_k));
" totals: sumc(sexptot_k)~sumc(exptot_k)~sumc(dexptot_k)"
(sumc(sexptot_k)~sumc(exptot_k)~sumc(dexptot_k));

" ";
" ";
" ";
" Data on total sales of French firms by market ";
" not including negs, including negs ";

call printfmt((cnty~xnf0~xnf),(0~1~1));

" ";
" ";
" Sales of French firms by market ";
" data (not including negs), baseline simulations, counterfactual simulation ";

call printfmt((cnty~xnf0~fsales~cffsales),(0~1~1~1));


bottomsgrowth2 = 100*(bottomscfsales - bottomssales)./bottomssales;
topsgrowth2 = 100*(topscfsales - topssales)./topssales;

" ";
" stuff for country-level table ";
x1 = fsales~dsales~pdsales~pdentry;
x1 = delif(x1,frvec);
" cntynofr~fsales~dsales~pdsales~pdentry";
call printfmt((cntynofr~x1),(0~1~1~1~1));
" totals ";
sumc(x1)';

" ";
" ";
x2 = entshare~bottomsgrowth2~topsgrowth2;
x2 = delif(x2,frvec);
" cntynofr~entshare~bottomsgrowth2~topsgrowth2 ";
call printfmt((cntynofr~x2),(0~1~1~1));

end;