pause on
* Figures to display estimation results
* for EKK  
*   October, 2008

clear
insheet using moc7tf20_pay.csv

scatter p95pay p50pay p95pay_sim p50pay_sim meanpay, legend(pos(3) col(1)lab(1 "data: 95th") lab(2 "data: 50th") lab(3 "model: 95th") lab(4 "model: 50th")) /*
  */ mcolor(black black cranberry cranberry) msize(small small small small) msymbol(smcircle smcircle_hollow smx smx) xscale(log) yscale(log) /*
 */ xlabel(.1 1) ylabel(.001 .01 .1 1 10, angle(horizontal)) /*
    */ ytitle("sales percentiles by market ($ millions)") xtitle("mean sales by market ($ millions)") /*
       */ title("Panel A: Sales Distribution by Market") saving(fig5a,replace) 

pause

scatter p95fr p50fr p95fr_sim p50fr_sim sun, legend(pos(3) col(1)lab(1 "data: 95th") lab(2 "data: 50th") lab(3 "model: 95th") lab(4 "model: 50th"))  /*
 */  mcolor(black black cranberry cranberry) msize(small small small small) xscale(log) yscale(log) msymbol(smcircle smcircle_hollow smx smx)  /*
  */  xlabel(100 1000 10000 100000) ylabel(.1 1 10 100 1000 10000, angle(horizontal)) /* 
   */ ytitle("sales percentiles in France ($ millions)") xtitle("# firms entering the market") /*
       */ title("Panel B: Sales in France by Market Penetrated") saving(fig5b,replace)

pause

gen np50rat = p50rat*1.572638/meanpay

gen np50rat_sim = p50rat_sim*1.572638/meanpay

gen np75rat = p75rat*1.572638/meanpay

gen np75rat_sim = p75rat_sim*1.572638/meanpay


scatter np50rat np50rat_sim sun if sun < 100000, legend(pos(3) col(1) lab(1 "data: 50th") lab(2 "model: 50th"))  /*
  */ mcolor(black cranberry) msize(small small) msymbol(smcircle smx) xscale(log) yscale(log) /*
 */ xlabel(100 1000 10000) ylabel(.001 .01 .1, angle(horizontal)) /*
    */ ytitle("percentiles of normalized export intensity") xtitle("# firms entering the market") /*
     */ title("Panel C: Export Intensity by Market") saving(fig5c,replace)

pause

gr combine fig5a.gph fig5b.gph fig5c.gph, iscale(.5) col(1) xsize(6.5) ysize(9) title("Figure 5: Model Versus Data")


