libname lib 'w:\travail\trade\donnees';

options nonotes nosource nomprint;

proc sort data=lib.pays out=pays;
  by country;
  run; 

data pays;
  set pays;
  by country;
  rename p5pay=p5payd p5fr=p5frd p5rat=p5ratd 
         q1pay=q1payd q1fr=q1frd q1rat=q1ratd
         medpay=medpayd medfr=medfrd medrat=medratd 
         q3pay=q3payd q3fr=q3frd q3rat=q3ratd 
         p95pay=p95payd p95fr=p95frd p95rat=p95ratd;
run;


proc sort data=lib.bal113(keep=siren ventfrd where=(ventfrd>0)) out=ekksir nodupkey;
  by siren;
  run;
    
data ekksir;
  set ekksir(drop=ventfrd);
  by siren;
  length default=4;
  nobs=_n_;
  run;

proc sort data=ekksir;
  by nobs;
  run;
%macro stat;
%do itir=1 %to 2000;

data tir;
  do i=1 to 229900;
  length default=4;
  x=uniform(&itir);
  nobs=1+int(229900*x);
  output;
  end;
  run;

proc sort data=tir;
  by nobs;
  run;

data sir;
  merge tir(in=a) ekksir;
  by nobs;
  if a;
  ident=_n_;
  run;
    
proc sort data=sir;
    by siren;
	run;
  
proc sort data=lib.bal113;
    by siren;
	run;
 
data sirinf;
set sir;
by siren;
retain replic;
if first.siren then replic=0;
replic=replic+1;
if last.siren then output;
run;

data structsir;
merge sirinf(in=a) lib.bal113;
by siren;
if a;
run;

proc sort data=structsir;
by siren paynum;run;

data structsir;
set structsir;
by siren paynum;
do rep=1 to replic;
  output;
end;
run;

data bal113;
  merge lib.bal113(in=b) structsir(in=a);
  by siren;
  if a ;
run;

data ekkmer02;
  set bal113;
  length default=4;
  if vfted>0;
  if ventfrd>0;
  if paynum=1
   ! paynum=10
   ! paynum=11
   ! paynum=2
   ! paynum=204
   ! paynum=208
   ! paynum=212
   ! paynum=216
   ! paynum=220
   ! paynum=224
   ! paynum=228
   ! paynum=232
   ! paynum=236
   ! paynum=240
   ! paynum=244
   ! paynum=248
   ! paynum=264
   ! paynum=268
   ! paynum=272
   ! paynum=276
   ! paynum=28
   ! paynum=280
   ! paynum=284
   ! paynum=288
   ! paynum=3
   ! paynum=30
   ! paynum=302
   ! paynum=306
   ! paynum=32
   ! paynum=322
   ! paynum=324
   ! paynum=328
   ! paynum=330
   ! paynum=334
   ! paynum=34
   ! paynum=342
   ! paynum=346
   ! paynum=350
   ! paynum=352
   ! paynum=36
   ! paynum=366
   ! paynum=370
   ! paynum=373
   ! paynum=378
   ! paynum=38
   ! paynum=382
   ! paynum=386
   ! paynum=390
   ! paynum=4
   ! paynum=400
   ! paynum=404
   ! paynum=412
   ! paynum=416
   ! paynum=424
   ! paynum=428
   ! paynum=432
   ! paynum=436
   ! paynum=442
   ! paynum=448
   ! paynum=456
   ! paynum=464
   ! paynum=472
   ! paynum=48
   ! paynum=480
   ! paynum=484
   ! paynum=5
   ! paynum=500
   ! paynum=504
   ! paynum=508
   ! paynum=512
   ! paynum=516
   ! paynum=52
   ! paynum=520
   ! paynum=524
   ! paynum=528
   ! paynum=56
   ! paynum=58
   ! paynum=6
   ! paynum=608
   ! paynum=612
   ! paynum=616
   ! paynum=62
   ! paynum=624
   ! paynum=628
   ! paynum=632
   ! paynum=636
   ! paynum=64
   ! paynum=649
   ! paynum=66
   ! paynum=660
   ! paynum=662
   ! paynum=664
   ! paynum=666
   ! paynum=669
   ! paynum=672
   ! paynum=68
   ! paynum=680
   ! paynum=690
   ! paynum=7
   ! paynum=70
   ! paynum=700
   ! paynum=701
   ! paynum=706
   ! paynum=708
   ! paynum=720
   ! paynum=728
   ! paynum=732
   ! paynum=736
   ! paynum=740
   ! paynum=8
   ! paynum=800
   ! paynum=801
   ! paynum=804
   ! paynum=9;
  un=1;
  sex=0;
  if nvfted113>0 then sex=nvfted113;
  seq=0;
  if (pay='002' and vfted>0) then seq=1000000;
  if (pay='004' and vfted>0) then seq=100000;
  if (pay='036' and vfted>0) then seq=10000;
  if (pay='005' and vfted>0) then seq=1000;
  if (pay='006' and vfted>0) then seq=100;
  if (pay='003' and vfted>0) then seq=10;
  if (pay='400' and vfted>0) then seq=1;
  vfted=vfted/1000;
  svfted=svfted/1000;
  svfted113=svfted113/1000;
  ventfrd=(1.622*ventfrd);
  vad=(cad-cid)*1.622;
  if capitd=. then capitd=0;
  capitd=capitd*1.622;
  if sald<20 then sald=20*effd;
  if charsod<10 then charsod=10*effd;
  coutrad=charsod+sald;
  if coutrad<30 then coutrad=30*effd;
  markup1d=vad/coutrad;
  markup4d=vad/sald;
  markup2d=cad/(cid+coutrad);
  markup5d=cad/(cid+sald);
  markup3d=cad/(cid+coutrad+0.03*capitd);
  markup6d=cad/(cid+sald+0.03*capitd);
  markup7d=vad/effd;
  if (markup1d>20 ! markup1d<0) then do;
    markup1d=.;markup2d=.;markup3d=.;markup4d=.;
	markup5d=.;markup6d=.;markup7d=.;
	end;

  vfte_sur_ventfrd=vfted/ventfrd;

  keep siren ident rep pay paynum un seq country vfted svfted113 svfted ventfrd vfte_sur_ventfrd sex
       markup1d markup2d markup3d markup4d markup5d markup6d markup7d;

  run;


proc sort data=ekkmer02;
    by country;
        run;

data ekkmer02;
  merge ekkmer02(in=a) pays(in=b);
  by country;
  if a & b;
  length default=4;
  p5pay=(0<=vfted<p5payd);
  p5fr=(0<=ventfrd<p5frd);
  p5rat=(0<=vfte_sur_ventfrd<p5ratd);
  q1pay=(p5payd<=vfted<q1payd);
  q1fr=(p5frd<=ventfrd<q1frd);
  q1rat=(p5ratd<=vfte_sur_ventfrd<q1ratd);
  medpay=(q1payd<=vfted<medpayd);
  medfr=(q1frd<=ventfrd<medfrd);
  medrat=(q1ratd<=vfte_sur_ventfrd<medratd);
  q3pay=(medpayd<=vfted<q3payd);
  q3fr=(medfrd<=ventfrd<q3frd);
  q3rat=(medratd<=vfte_sur_ventfrd<q3ratd);
  p95pay=(q3payd<=vfted<p95payd);
  p95fr=(q3frd<=ventfrd<p95frd);
  p95rat=(q3ratd<=vfte_sur_ventfrd<p95ratd);
  run;

proc summary data=ekkmer02;
   by country;
   var un;
   output out=paynum sum=sun;
   run;

data paynum;
  set paynum;
  drop _freq_ _type_;
  run;


proc summary data=ekkmer02 noprint;
   by country;
   var p5pay p5fr p5rat q1pay q1fr q1rat medpay medfr medrat q3pay q3fr q3rat p95pay p95fr p95rat;
   output out=paydis mean= ;
   run;


proc sort data=lib.pays(keep=country pay paynum) out=paysint;
  by country;
  run;


proc sort data=paynum;
  by country;
  run;

  
proc sort data=bal113(where=(ventfrd>0)) out=france nodupkeys;
  by siren;
run;

data structfrance;
merge sirinf(in=a) france;
by siren;
if a;
run;

data structfrance;
set structfrance;
by siren;
do rep=1 to replic;
  output;
end;
run;

data france;
  set structfrance(keep=ident);
  length default=4;
  length country $48;
  length pay $3;
  country='FRANCE';
  pay='001';
  som=1;
  paynum=1;
run;

proc summary data=france;
  id country pay;
  var som paynum;
  output out=fragg mean=som paynum sum=sun spay;
run;

data fragg;
  set fragg;
  keep country pay paynum sun;
run;

proc sort data=fragg(keep=country pay sun paynum) out=frasun;
  by country;
  run;

data paysditir;
  merge paysint(in=a) frasun paynum paydis;
  by country;
run;



  /* et maintenant la france */


proc sort data=bal113(where=(ventfrd>0)) out=france nodupkeys;
  by ident;
run;

data structfrance;
merge sirinf(in=a) france;
by siren;
if a;
length country $48;
  country='FRANCE';
run;

data structfrance;
set structfrance;
by siren;
do rep=1 to replic;
  output;
end;
run;

data fraanal;
  merge structfrance(in=a) pays(in=b);
  by country;
  if a & b;
  keep siren ident country ventfrd vfte_sur_ventfrd
       p5pay p5fr p5rat q1pay q1fr q1rat medpay medfr medrat 
       q3pay q3fr q3rat p95pay p95fr p95rat;
  if ventfrd>0;
  ventfrd=(1.622*ventfrd);
  length default=4;
  vfte_sur_ventfrd=1;
  p5pay=(0<=ventfrd<p5payd);
  p5fr=(0<=ventfrd<p5frd);
  p5rat=(0<=vfte_sur_ventfrd<p5ratd);
  q1pay=(p5payd<=ventfrd<q1payd);
  q1fr=(p5frd<=ventfrd<q1frd);
  q1rat=(p5ratd<=vfte_sur_ventfrd<q1ratd);
  medpay=(q1payd<=ventfrd<medpayd);
  medfr=(q1frd<=ventfrd<medfrd);
  medrat=(q1ratd<=vfte_sur_ventfrd<medratd);
  q3pay=(medpayd<=ventfrd<q3payd);
  q3fr=(medfrd<=ventfrd<q3frd);
  q3rat=(medratd<=vfte_sur_ventfrd<q3ratd);
  p95pay=(q3payd<=ventfrd<p95payd);
  p95fr=(q3frd<=ventfrd<p95frd);
  p95rat=(q3ratd<=vfte_sur_ventfrd<p95ratd);
run;


proc summary data=fraanal noprint;
   by country;
   var p5pay p5fr p5rat q1pay q1fr q1rat medpay medfr medrat q3pay q3fr q3rat p95pay p95fr p95rat;
   output out=fradis mean= ;
   run;

data paysditir;
  merge paysditir fradis;
  by country;
  run;

run;

data payfin;
set %if &itir ne 1 %then %do; payfin %end; paysditir(in=a);
if a then itir=&itir;
run;


%end;
%mend;

%stat;

data lib.payfin102008;
  set payfin;
  run;
   
data lib.payfin102008a;
 set lib.payfin102008;
 if itir <=500;
 run;

data lib.payfin102008b;
 set lib.payfin102008;
 if 500<itir <=1000;
 run;

data lib.payfin102008c;
 set lib.payfin102008;
 if 1000<itir <=1500;
 run;
 
data lib.payfin102008d;
 set lib.payfin102008;
 if 1500<itir <=2000;
 run;
