pause on
* September, 2008
* Resample 1986 data for bootstrap
* 

clear
set memory 1000m


* I included France in country.dta
use c:\kortum\research\EKK\chi1008\country
* French data already combine Belgium and Luxembourg
drop if uncode==442
sort paysnum
save country2, replace
clear

* thousands of French Francs

use c:\kortum\research\EKK\chi1008\payfin102008a
append using c:\kortum\research\EKK\chi1008\payfin102008b
append using c:\kortum\research\EKK\chi1008\payfin102008c
append using c:\kortum\research\EKK\chi1008\payfin102008d

rename paynum paysnum
gen pay0_50 = p5pay + q1pay + medpay
gen fr0_50 = p5fr + q1fr + medfr
gen rat0_50 = p5rat + q1rat + medrat

gen pay50_75 = q3pay
gen fr50_75 = q3fr
gen rat50_75 = q3rat

gen pay75_95 = p95pay
gen fr75_95 = p95fr

gen pay95_100 = 1 - pay0_50 - pay50_75 - pay75_95
gen fr95_100 = 1 - fr0_50 - fr50_75 - fr75_95

gen rat75_100 = 1 - rat0_50 - rat50_75 

keep paysnum pay0_50 pay50_75 pay75_95 pay95_100 fr0_50 fr50_75 fr75_95 fr95_100 rat0_50 rat50_75 rat75_100 itir
sort paysnum
merge paysnum using country2
keep if _merge==3
drop _merge
drop if country=="FRANCE"

sort itir country

outfile pay0_50 pay50_75 pay75_95 pay95_100 fr0_50 fr50_75 fr75_95 fr95_100 rat0_50 rat50_75 rat75_100 itir using c:\kortum\research\EKK\chi1008\payfin2000p, replace

 collapse (sd) pay0_50 pay50_75 pay75_95 pay95_100 fr0_50 fr50_75 fr75_95 fr95_100 rat0_50 rat50_75 rat75_100, by(country)
gen vpay0_50 = pay0_50^2
gen vpay50_75 = pay50_75^2
gen vpay75_95 = pay75_95^2 
gen vpay95_100 = pay95_100^2 

gen vfr0_50 = fr0_50^2
gen vfr50_75 = fr50_75^2 
gen vfr75_95 = fr75_95^2
gen vfr95_100 = fr95_100^2

gen vrat0_50 = rat0_50^2 
gen vrat50_75 = rat50_75^2
gen vrat75_100 = rat75_100^2

